/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define VRAI (1)
#define FAUX (0)


void patpack (N, M, step, step1, step2, t0, t1, n, nom, msb0)
	long N, M;
	int step, step1, step2;
	int t0, t1, n;
	char *nom;
	int  msb0;
{
int 	i,j;
int 	cur_vect;
char 	filepat[16];
FILE 	*f;
char *updown= msb0 ? "to" : "downto";
int dM= msb0 ? 0: (M-1);
int fM= msb0 ? (M-1): 0;
int dN= msb0 ? 0: (N-1);
int fN= msb0 ? (N-1): 0;
int dP= msb0 ? 0: (N+M-1);
int fP= msb0 ? (N+M-1): 0;


/********************************************************************************/
/*			OUVERTURE DU FICHIER .pat				*/
/********************************************************************************/
sprintf (filepat,"%s.pat"  ,nom);
f=fopen (filepat,"w");
fprintf (f,	"-- patterns for booth multiplier				\n");
fprintf (f,	"								\n\n");
fprintf (f,	"-- input / output list :					\n");
fprintf (f,	"in	a (%d    %s  %d) B;;;					\n",
			   dM,updown,fM);

fprintf (f,	"in	b (%d    %s  %d) B;;;					\n",
			   dN,updown,fN);

fprintf (f,	"out	p (%d    %s  %d) B;;;					\n\n",
			   dP,updown,fP);

fprintf (f,	"begin								\n");
fprintf (f,	"-- a"								);
nspace (f,M+1);
fprintf (f,	"b"								);
nspace (f,N+2);
fprintf (f,	"p\n\n"								);


for (i=0;i<M;i=i+1)
	{
	for (j=0;j<N;j=j+1)
		{
		fprintf (f,	" : "						);
		kron (f,i,M);
		fprintf (f,	"  "						);
		kron (f,j,N);
		fprintf (f,	"  ?"						);
		nstar (f,M+N);
		fprintf (f,	"  ;\n"						);
		}
	}
fprintf (f, "\nend;								\n");
fclose(f);
}



/********************************************************************/
/*        REMPLIT AVEC p zero					    */
/********************************************************************/
full0 (fpt,p)
int 	p;
FILE 	*fpt;
{
int k,count=1;
while ( (count++) < (p+1))	fprintf (fpt,"0");
}
/********************************************************************/



/********************************************************************/
/*        REMPLIT AVEC p  un					    */
/********************************************************************/
full1 (p,fpt)
int 	p;
FILE 	*fpt;
{
int k,count=1;
while ( (count++) < (p+1))	fprintf (fpt,"1");
}
/********************************************************************/



/********************************************************************/
/*			REMPLIT AVEC 0101			    */
/********************************************************************/
full5 (fpt)
FILE	*fpt;
{
fprintf (fpt,"0");
fprintf (fpt,"1");
fprintf (fpt,"0");
fprintf (fpt,"1");
}
/********************************************************************/



/********************************************************************/
/*			REMPLIT AVEC 1010			    */
/********************************************************************/
full10 (fpt)
FILE	*fpt;
{
fprintf (fpt,"1");
fprintf (fpt,"0");
fprintf (fpt,"1");
fprintf (fpt,"0");
}
/********************************************************************/


/********************************************************************/
/*			REMPLIT AVEC 0011			    */
/********************************************************************/
full3 (fpt)
FILE	*fpt;
{
fprintf (fpt,"0");
fprintf (fpt,"0");
fprintf (fpt,"1");
fprintf (fpt,"1");
}
/********************************************************************/






/*************************************************************************/
/* Ecrit 2^k en base 2 code sur size bits dans le fichier pointe par fpt */
/*************************************************************************/
kron (fpt,k,size)
FILE 	*fpt;
int	k;
int	size;
{
full0 (fpt,size-k-1);
fprintf (fpt,"1"					);				
full0 (fpt,k);
}
/************************************************************************/





/************************************************************************/
/*			ecrit n espaces					*/
/************************************************************************/
nspace (fpt,k)
FILE 	*fpt;
int 	k;
{
int count=1;
while (count++ < k+1) fprintf (fpt,	" ");
}
/************************************************************************/




/************************************************************************/
/*			ecrit n etoiles					*/
/************************************************************************/
nstar (fpt,k)
FILE 	*fpt;
int 	k;
{
int count=1;
while (count++ < k+1) fprintf (fpt,	"*");
}
/************************************************************************/
