/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    Fichier     :    strecher_dtdupl.h

    Date        :    12 octobre 1995
    Version     :    2.0

    Auteur      :    CHAPUT Jean-Paul
    Modifie par :    BEAURIN Oliver

\*********************************************************************/

#ifndef DTDUPL_H
#define DTDUPL_H

/* Constantes du module : */
#define        C_TDUPL_SZ_NAME         MBK_SZ_NAME
#define        C_TDUPL_USER            1
#define        C_TDUPL_INDEX           2
#define        C_TDUPL_FREE            3

#define        F_TDUPL_USER            1L       /* bit  1 */
#define        F_TDUPL_INDEX           2L       /* bit  2 */
#define        F_TDUPL_PHDUP           4L       /* bit  3 */
#define        F_TDUPL_PHFIG           8L       /* bit  4 */
#define        F_TDUPL_STRECH         16L       /* bit  5 */
#define        F_TDUPL_CMA            32L       /* bit  6 */
#define        F_TDUPL_TALLOC         64L       /* bit  7 */
#define        F_TDUPL_TALU          128L       /* bit  8 */
#define        F_TDUPL_THROUGH       256L       /* bit  9 */
#define        F_TDUPL_BLOCK         512L       /* bit 10 */
#define        F_TDUPL_TERMINAL     1024L       /* bit 11 */
#define        F_TDUPL_CLEAN        2048L       /* bit 12 */

/* Structure contenant les informations sur un duplicata. */
typedef struct dtdupl
{
    struct phfig   *PHFIG;      /* modele de reference ( non streche ) */
    struct phfig   *PHDUP;      /* figure strechee : duplicata.        */
    struct phcut   *PHCUT;      /* liste des coupes.                   */
    char           *FIGNAME;    /* nom de la figure d'origine.         */
    char           *DUPNAME;    /* nom de la figure duplicata.         */
    long            FLAGS;      /* drapeaux d'etats.                   */
    struct dtdupl  *NEXT;       /* chainage des objets.                */
}               dtdupl_list;


extern dtdupl_list *TABLE_DUPL;


/* Fonctions d'interface du module : */
extern dtdupl_list *allocdtdupl();
extern void         freedtdupl();
extern void         nameddtdupl();
extern dtdupl_list *getdtdupl();
extern dtdupl_list *getdtdupl_byphdup();
extern dtdupl_list *getdtdupl_byphfig();

#endif                          /* DTDUPL_H */
