/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  Message.c                        |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/PushBG.h>
# include <Xm/CascadeBG.h>
 

# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include RFM_H
# include GRD_H
# include GMX_H
# include GTB_H
# include GSB_H
# include GMV_H
# include "GMV_message.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static char MessageBuffer[ 512 ];

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       DrealPromptZoomIn                     |
|                                                             |
\------------------------------------------------------------*/

void DrealPromptZoomIn()

{
  rdsbegin();

  DrealDisplayMessage( DREAL_MESSAGE_MODE, "Zoom In" );
  DrealDisplayMessage( DREAL_MESSAGE_INFO, "Select window" );

  switch ( DrealCountEventZoom )
  {
    case 0 : 

      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter first corner" );

    break;

    case 1 :

      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter second corner" );
  }

  rdsend();
}

/*------------------------------------------------------------\
|                                                             |
|                       DrealPromptZoomPan                    |
|                                                             |
\------------------------------------------------------------*/

void DrealPromptZoomPan()

{
  rdsbegin();

  DrealDisplayMessage( DREAL_MESSAGE_MODE, "Zoom Pan" );
  DrealDisplayMessage( DREAL_MESSAGE_INFO, "Select line"  );

  switch ( DrealCountEventZoom )
  {
    case 0 : 

      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter source point" );

    break;

    case 1 : 

      DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter target point" );
  }

  rdsend();
}

/*------------------------------------------------------------\
|                                                             |
|                    DrealPromptZoomCenter                    |
|                                                             |
\------------------------------------------------------------*/

void DrealPromptZoomCenter()

{
  rdsbegin();

  DrealDisplayMessage( DREAL_MESSAGE_MODE, "Zoom Center" );
  DrealDisplayMessage( DREAL_MESSAGE_INFO, "Select point" );
  DrealDisplayMessage( DREAL_MESSAGE_PROMPT, "Enter center point" );

  rdsend();
}

