/*------------------------------------------------------------\
|                                                             |
| File    :                  Search.c                         |
|                                                             |
| Author  :                Jacomme Ludovic                    |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include RFM_H
# include GRD_H
# include GSB_H
# include "GRD_search.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  drealsearch *DrealHeadSearch = (drealsearch *)NULL;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Alloc Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        DrealAllocSearch                     |
|                                                             |
\------------------------------------------------------------*/

drealsearch *DrealAllocSearch()
{
  return((drealsearch *)rdsalloc(sizeof(drealsearch), 1));
}

/*------------------------------------------------------------\
|                                                             |
|                        Free Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         DrealFreeSearch                     |
|                                                             |
\------------------------------------------------------------*/

void DrealFreeSearch( FreeSearch )

   drealsearch *FreeSearch;
{
  rdsfree((char *)FreeSearch, sizeof(drealsearch));
}

/*------------------------------------------------------------\
|                                                             |
|                       DrealAddSearch                        |
|                                                             |
\------------------------------------------------------------*/

void DrealAddSearch( Rectangle )

   rdsrec_list *Rectangle;
{
  drealsearch *Search;

  rdsbegin();

  Search = DrealAllocSearch();

  Search->RECTANGLE = Rectangle;
  Search->NEXT      = DrealHeadSearch;
  DrealHeadSearch   = Search;

  rdsend();
}

/*------------------------------------------------------------\
|                                                             |
|                       DrealDelSearch                        |
|                                                             |
\------------------------------------------------------------*/

void DrealDelSearch()

{
  drealsearch *Search;

  rdsbegin();

  while ( DrealHeadSearch != (drealsearch *)NULL )
  {
    Search          = DrealHeadSearch;
    DrealHeadSearch = DrealHeadSearch->NEXT;

    DrealFreeSearch( Search );
  }

  rdsend();
}
