/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  Window.h                         |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef GRD_WINDOW
# define GRD_WINDOW

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define DREAL_DEFAULT_WINDOW_XMIN   -4000
# define DREAL_DEFAULT_WINDOW_YMIN   -4000
# define DREAL_DEFAULT_WINDOW_XMAX   16000
# define DREAL_DEFAULT_WINDOW_YMAX   16000
# define DREAL_DEFAULT_WINDOW_DX       100
# define DREAL_DEFAULT_WINDOW_DY       100
# define DREAL_DEFAULT_WINDOW_SIDE     200
 
# define DREAL_WINDOW_BORDER          4000

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void DrealInitializeWindow();
  extern void DrealCheckWindow();
  extern void DrealEraseWindow();

  extern void DrealInsertRectangle();
  extern void DrealEraseRectangle();
  extern void DrealEraseRecWin();
 
  extern void DrealViewWindow();

# endif 
