/*
 * $Author: ac $
 * $Id: bflerr.c,v 1.1 1999/10/21 12:51:50 ac Exp $
 * $Date: 1999/10/21 12:51:50 $
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include BFL_H

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

#ifdef SunOS

extern char *sys_errlist[];
extern int errno, sys_nerr;

static char *
strerror(nerr)
    int nerr;
{
    if (nerr < sys_nerr)
	return sys_errlist[nerr];
    else
	return "unknown error";
}

#endif

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

void
#ifdef __STDC__
bflsyserror(int eval, const char *fmt,...)
#else
bflsyserror(eval, fmt, va_alist)
    int eval;
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif
#if 0
    (void) fprintf(stderr, "%s: ", __progname);
#else
    (void) fprintf(stderr, "[01;36m%s:[0m [01;35m", __progname);
#endif
    if (fmt != NULL) {
	(void) vfprintf(stderr, fmt, ap);
	(void) fprintf(stderr, ": ");
    }
    (void) fprintf(stderr, "%s", strerror(errno));
#if 0
    (void) fprintf(stderr, "\n");
#else
    (void) fprintf(stderr, "[0m\n");
#endif
    exit(eval);
    va_end(ap);
}

void
#ifdef __STDC__
bflerror(int eval, const char *fmt,...)
#else
bflerror(eval, fmt, va_alist)
    int eval;
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif
#if 0
    (void) fprintf(stderr, "%s: ", __progname);
#else
    (void) fprintf(stderr, "[01;36m%s:[0m [01;35m", __progname);
#endif
    if (fmt != NULL)
	(void) vfprintf(stderr, fmt, ap);
#if 0
    (void) fprintf(stderr, "\n");
#else
    (void) fprintf(stderr, "[0m\n");
#endif
    exit(eval);
    va_end(ap);
}

void
#ifdef __STDC__
bflsyswarning(const char *fmt,...)
#else
bflsyswarning(fmt, va_alist)
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif
#if 0
    (void) fprintf(stderr, "%s: ", __progname);
#else
    (void) fprintf(stderr, "[01;36m%s:[0m [01;33m", __progname);
#endif
    if (fmt != NULL) {
	(void) vfprintf(stderr, fmt, ap);
	(void) fprintf(stderr, ": ");
    }
    (void) fprintf(stderr, "%s", strerror(errno));
#if 0
    (void) fprintf(stderr, "\n");
#else
    (void) fprintf(stderr, "[0m\n");
#endif
    va_end(ap);
}

void
#ifdef __STDC__
bflwarning(const char *fmt,...)
#else
bflwarning(fmt, va_alist)
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif
#if 0
    (void) fprintf(stderr, "%s: ", __progname);
#else
    (void) fprintf(stderr, "[01;36m%s:[0m [01;33m", __progname);
#endif
    if (fmt != NULL)
	(void) vfprintf(stderr, fmt, ap);
#if 0
    (void) fprintf(stderr, "\n");
#else
    (void) fprintf(stderr, "[0m\n");
#endif
    va_end(ap);
}
