/*
 * $Author: ac $
 * $Id: testtree.c,v 1.2 1999/10/21 12:51:55 ac Exp $
 * $Date: 1999/10/21 12:51:55 $
 */
/*
 * $Log: testtree.c,v $
 * Revision 1.2  1999/10/21 12:51:55  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:38  alliance
 * fpmap import
 *
 */

#include <stdio.h>
#include BFL_H

static int
intcmp(const bflptr_t x, const bflptr_t y)
{
    return (int) x - (int) y;
}

static void
print_tree(char *label, bfltree_t * tree)
{
    bfltreenode_t *first;
    bfltreenode_t *last;

    first = bfltreebegin(tree);
    last = bfltreeend(tree);
    printf("%s", label);
    while (first != last) {
	printf(" %d", (int) bfltreedata(first));
	first = bfltreenext(first);
    }
    printf("\n");
}

int
main(int argc, char **argv)
{
    bfltree_t *tree;
    bfltreenode_t *node;

    tree = bfltreenew(intcmp, 0);

    bfltreeinsert(tree, (bflptr_t) 0);
    bfltreeinsert(tree, (bflptr_t) 1);
    bfltreeinsert(tree, (bflptr_t) 2);
    bfltreeinsert(tree, (bflptr_t) 3);
    bfltreeinsert(tree, (bflptr_t) 4);
    bfltreeinsert(tree, (bflptr_t) 5);
    bfltreeinsert(tree, (bflptr_t) 6);
    bfltreeinsert(tree, (bflptr_t) 7);
    bfltreeinsert(tree, (bflptr_t) 8);
    bfltreeinsert(tree, (bflptr_t) 9);

    print_tree("tree", tree);

    node = bfltreefind(tree, (bflptr_t) 9);
    printf("bfltreefind(tree, 9) =  %d\n", (int) bfltreedata(node));
    puts("bfltreeerase(tree, 9)");
    bfltreeerase(tree, node);

    print_tree("tree", tree);

    node = bfltreefind(tree, (bflptr_t) 0);
    printf("bfltreefind(tree, 0) =  %d\n", (int) bfltreedata(node));
    puts("bfltreeerase(tree, 0)");
    bfltreeerase(tree, node);

    print_tree("tree", tree);

    node = bfltreefind(tree, (bflptr_t) 5);
    printf("bfltreefind(tree, 5) =  %d\n", (int) bfltreedata(node));
    puts("bfltreeerase(tree, 5)");
    bfltreeerase(tree, node);

    print_tree("tree", tree);

    bfltreefree(tree);

    return 0;
}
