/*
 * $Author: ac $
 * $Id: fpm_util.c,v 1.2 1999/10/21 12:52:08 ac Exp $
 * $Date: 1999/10/21 12:52:08 $
 */
/*
 * $Log: fpm_util.c,v $
 * Revision 1.2  1999/10/21 12:52:08  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 * Revision 1.1  1997/11/14 11:49:46  ac
 * Initial revision
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include  MUT_H
#include  BFL_H
#include  AUT_H
#include  ABL_H
#include  BDD_H
#include  ABE_H
#include "fpm_network.h"
#include "fpm_user.h"
#include "fpm_util.h"

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                            fpmsupportsize                            */
/*----------------------------------------------------------------------*/

int 
fpm_support_size(List1, List2)
	chain_list *List1;
	chain_list *List2;
{
	int Size = 0;
	chain_list *Ptr;

	while (List2) {
		for (Ptr = List1; Ptr != 0; Ptr = Ptr->NEXT)
			if (Ptr->DATA == List2->DATA)
				goto suivant;
		Size += 1;
	      suivant:
		List2 = List2->NEXT;
	}
	for (Ptr = List1; Ptr != 0; Ptr = Ptr->NEXT)
		Size += 1;
	return Size;
}

/*----------------------------------------------------------------------*/
/*                             fpmmergechain                            */
/*----------------------------------------------------------------------*/

chain_list *
fpm_merge_chain(List1, List2)
	chain_list *List1;
	chain_list *List2;
{
	chain_list *Ptr1 = List1;
	chain_list *Ptr2 = List2;

	while (Ptr2 != 0) {
		while (Ptr1 != 0) {
			if (Ptr1->DATA == Ptr2->DATA)
				goto suivant;
			Ptr1 = Ptr1->NEXT;
		}
		List1 = addchain(List1, Ptr2->DATA);
	      suivant:
		Ptr1 = List1;
		Ptr2 = Ptr2->NEXT;
	}
	freechain(List2);
	return List1;
}

/*----------------------------------------------------------------------*/
/*                            fpmlengthchain                            */
/*----------------------------------------------------------------------*/

int 
fpm_length_chain(List)
	chain_list *List;
{
	int Length = 0;

	while (List != 0) {
		Length += 1;
		List = List->NEXT;
	}
	return Length;
}

/*----------------------------------------------------------------------*/
/*                             fpmissavedaux                            */
/*----------------------------------------------------------------------*/

int 
fpm_is_saved_aux(SavedAux, Name)
	chain_list *SavedAux;
	char *Name;
{
	while (SavedAux != 0)
		if (SavedAux->DATA == Name)
			return 1;
		else
			SavedAux = SavedAux->NEXT;

	return 0;
}
