/*
 * $Author: ac $
 * $Id: klut.h,v 1.2 1999/10/21 12:52:08 ac Exp $
 * $Date: 1999/10/21 12:52:08 $
 */
/*
 * $Log: klut.h,v $
 * Revision 1.2  1999/10/21 12:52:08  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 */

#ifndef __klut_h
#define __klut_h

/*----------------------------------------------------------------------*/
/*                           Nested includes                            */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

#define KLUT_MAPPED		( 1 << 1 )	/*  2 */
#define KLUT_INVERTED		( 1 << 2 )	/*  4 */

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

#ifndef __P
#ifdef __STDC__
#define __P(args)	args
#else
#define __P(args)	()
#endif
#endif

#define KLUT_IS_MAPPED( Flag )		( Flag & KLUT_MAPPED )
#define KLUT_IS_INVERTED( Flag )	( Flag & KLUT_INVERTED )

#define KLUT_SET_MAPPED( Flag)		( Flag |= KLUT_MAPPED )
#define KLUT_SET_INVERTED( Flag)	( Flag |= KLUT_INVERTED )

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                         Function prototypes                          */
/*----------------------------------------------------------------------*/

extern void	 klut_init   __P((void));
extern void	 klut_done   __P((void));
extern void	 klut_check  __P((void));
extern void	 klut_cost   __P((fpm_expr_t *, long *, long *));
extern void	 klut_clear  __P((fpm_atom_t *));
extern ablexpr	*klut_mapp   __P((bddnode *Node, int CreateAux));
extern void	 klut_report __P((void));
extern void	 klut_save   __P((void));

#endif	/* __klut_h */
