/*
 * $Author: ac $
 * $Id: x4000.h,v 1.2 1999/10/21 12:52:09 ac Exp $
 * $Date: 1999/10/21 12:52:09 $
 */
/*
 * $Log: x4000.h,v $
 * Revision 1.2  1999/10/21 12:52:09  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 * Revision 1.2  1998/01/26 15:29:10  ac
 * Bug fix in the mapping function.
 *
 * Revision 1.1  1997/11/14 11:49:46  ac
 * Initial revision
 *
 */

#ifndef x4000_h
#define x4000_h

/*----------------------------------------------------------------------*/
/*                           Nested includes                            */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

#define X4_MASK_MAPPED		( 1 << 1 )	/*  2 */
#define X4_MASK_INVERTED	( 1 << 2 )	/*  4 */
#define X4_MASK_CLB_F		( 1 << 3 )	/*  8 */
#define X4_MASK_CLB_H		( 1 << 4 )	/* 16 */
#define X4_MASK_CLB		( X4_MASK_CLB_F | X4_MASK_CLB_H )

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

#ifndef __P
#ifdef __STDC__
#define __P(args)	args
#else
#define __P(args)	()
#endif
#endif

#define X4_IS_MAPPED( Flag )	( Flag & X4_MASK_MAPPED )
#define X4_IS_INVERTED( Flag )	( Flag & X4_MASK_INVERTED )
#define X4_IS_CLB_F( Flag )	( Flag & X4_MASK_CLB_F )
#define X4_IS_CLB_H( Flag )	( Flag & X4_MASK_CLB_H )
#define X4_IS_CLB( Flag )	( Flag & X4_MASK_CLB )

#define X4_SET_MAPPED( Flag)	( Flag |= X4_MASK_MAPPED )
#define X4_SET_INVERTED( Flag)	( Flag |= X4_MASK_INVERTED )
#define X4_SET_CLB_F( Flag )	( Flag |= X4_MASK_CLB_F )
#define X4_SET_CLB_H( Flag )	( Flag |= X4_MASK_CLB_H )

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                         Function prototypes                          */
/*----------------------------------------------------------------------*/

extern void	 x4_init   __P((void));
extern void	 x4_done   __P((void));
extern void	 x4_check  __P((void));
extern void	 x4_cost   __P((fpm_expr_t *, long *, long *));
extern void	 x4_clear  __P((fpm_atom_t *));
extern ablexpr	*x4_mapp   __P((bddnode *Node, int CreateAux));
extern void	 x4_report __P((void));
extern void	 x4_save   __P((void));

#endif	/* x4000_h */
