/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*------------------------------------------------------------\
|                                                             |
| Tool    :                   GenView                         |
|                                                             |
| File    :                  D_stdlib.h                       |
|                                                             |
| Authors :                Frederic Petrot                    |
|                    Modified by Ludovic Jacomme              |
|                                                             |
| Date    :                   30.04.94                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                             Constants                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef D_STDLIB_H 
# define D_STDLIB_H 

# ifdef pc
# undef pc
# endif

# define PREND_SHORT(X)  *((short*)(&(X)))
# define PREND_INT(X)    *((int*)(&(X)))
# define PREND_FLOAT(X)  *((float*)(&(X)))
# define PREND_DOUBLE(X) *((double*)(&(X)))

# define READ_SHORT(X)   *((short*)(X))
# define READ_INT(X)     *((int*)(X))
# define READ_FLOAT(X)   *((float*)(X))
# define READ_DOUBLE(X)  *((double*)(X))

# define QI 0            /* code QI 0 */
# define HI 1            /* code HI 1 */
# define SI 2            /* code SI 2 */
# define DF 3            /* code DF 3 */
# define SF 4            /* code SF 4 */

/* Internally known functions. Alphanumerical ASCII order */

# define NB_FONC_LIB 51 /* number of entries in the dictionnary */

/*------------------------------------------------------------\
|                                                             |
|                            Macros                           |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                             Variables                       |
|                                                             |
\------------------------------------------------------------*/

  extern int taille_TabFonc;
  extern FONC TabFonc[NB_FONC_LIB + 1];

/*------------------------------------------------------------\
|                                                             |
|                             Functions                       |
|                                                             |
\------------------------------------------------------------*/

 extern MULT_TYP GetParam();
 extern int app_atoi();
 extern int app_malloc();
 extern int app_bcopy();
 extern int app_flsbuf();
 extern int app_strlen();
 extern int app_strcmp();
 extern int app_namealloc();
 extern void ConvOct();
 extern void EffectuePrintf();
 extern char *base_printf();
 extern int app_printf();
 extern int app_sprintf();
 extern int app_NAME();
 extern int app_DEF_PHFIG();
 extern int app_DEF_PHINS();
 extern int app_DEF_AB();
 extern int app_PLACE();
 extern int app_PLACE_RIGHT();
 extern int app_PLACE_LEFT();
 extern int app_PLACE_TOP();
 extern int app_PLACE_BOTTOM();
 extern int app_PLACE_REF();
 extern int app_PLACE_ON();
 extern int app_PHCON();
 extern int app_PHSEG();
 extern int app_PHREF();
 extern int app_PHVIA();
 extern int app_PLACE_CON_REF();
 extern int app_PLACE_SEG_REF();
 extern int app_PLACE_VIA_REF();
 extern int app_COPY_UP_SEG();
 extern int app_COPY_UP_REF();
 extern int app_COPY_UP_CON_FACE();
 extern int app_COPY_UP_CON();
 extern int app_THRU_CON_H();
 extern int app_THRU_CON_V();
 extern int app_THRU_H();
 extern int app_THRU_V();
 extern int app_GET_CON_X();
 extern int app_GET_CON_Y();
 extern int app_GET_INS_X();
 extern int app_GET_INS_Y();
 extern int app_GET_REF_X();
 extern int app_GET_REF_Y();
 extern int app_WIDTH();
 extern int app_HEIGHT();
 extern int app_WIRE1();
 extern int app_WIRE2();
 extern int app_WIRE3();
 extern int app_COPY_UP_ALL_CON();
 extern int app_COPY_UP_ALL_REF();
 extern int app_FLATTEN_PHFIG();
 extern int app_FLATTEN_ALL_PHINS();

# endif
