/*------------------------------------------------------------\
|                                                             |
| File    :                  Search.c                         |
|                                                             |
| Author  :                Jacomme Ludovic                    |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include RFM_H
# include GRM_H
# include GSB_H
# include "GRM_search.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  graalsearch *GraalHeadSearch = (graalsearch *)NULL;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Alloc Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        GraalAllocSearch                     |
|                                                             |
\------------------------------------------------------------*/

graalsearch *GraalAllocSearch()
{
  return((graalsearch *)rdsalloc(sizeof(graalsearch), 1));
}

/*------------------------------------------------------------\
|                                                             |
|                        Free Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         GraalFreeSearch                     |
|                                                             |
\------------------------------------------------------------*/

void GraalFreeSearch( FreeSearch )

   graalsearch *FreeSearch;
{
  rdsfree((char *)FreeSearch, sizeof(graalsearch));
}

/*------------------------------------------------------------\
|                                                             |
|                       GraalAddSearch                        |
|                                                             |
\------------------------------------------------------------*/

void GraalAddSearch( Rectangle )

   rdsrec_list *Rectangle;
{
  graalsearch *Search;

  rdsbegin();

  Search = GraalAllocSearch();

  Search->RECTANGLE = Rectangle;
  Search->NEXT      = GraalHeadSearch;
  GraalHeadSearch   = Search;

  rdsend();
}

/*------------------------------------------------------------\
|                                                             |
|                       GraalDelSearch                        |
|                                                             |
\------------------------------------------------------------*/

void GraalDelSearch()

{
  graalsearch *Search;

  rdsbegin();

  while ( GraalHeadSearch != (graalsearch *)NULL )
  {
    Search          = GraalHeadSearch;
    GraalHeadSearch = GraalHeadSearch->NEXT;

    GraalFreeSearch( Search );
  }

  rdsend();
}
