/*------------------------------------------------------------\
|                                                             |
| Tool    :                   LYNX                            |
|                                                             |
| File    :                  pattern.c                        |
|                                                             |
| Authors :               Jacomme Ludovic                     |
|                                                             |
| Date    :                  01.07.95                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef LYNX_PATTERN_H
# define LYNX_PATTERN_H

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                   Max Width and Length in lambda            |
|                                                             |
\------------------------------------------------------------*/

# define LYNX_MAX_WIDTH   10
# define LYNX_MAX_LENGTH  10

/*------------------------------------------------------------\
|                                                             |
|                             Macros                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Lynx Pattern List                      |
|                                                             |
\------------------------------------------------------------*/

  typedef struct lynxpattern
  {
    rdsrec_list  *REAL[ LYNX_MAX_ORIENT ];
    rdsrec_list  *SYMB[ LYNX_MAX_ORIENT ];
    long          WIDTH;

  } lynxpattern;
  
/*------------------------------------------------------------\
|                                                             |
|                      Lynx Transistor List                   |
|                                                             |
\------------------------------------------------------------*/

  typedef struct lynxtrans
  {
    struct lynxtrans   *NEXT;
    struct lynxpattern  PATTERN[ LYNX_MAX_WIDTH ];
    char                MBK_LAYER;
    char                GATE_LAYER;
    char                DIFF_LAYER;
    char                ACTIV_LAYER;
    char                ORIENT;
    long                LENGTH;

  } lynxtrans_list;

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern long LynxReconizeTransistor();

# endif
