/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Abl                           |
|                                                             |
| File    :                   abladd.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H

# include <stdio.h>
# include "abladd.h"
# include "ablerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static ablexpr *AblQueueExpr = (ablexpr *)0;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Add  Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Add Abl Queue Expr                    |
|                                                             |
\------------------------------------------------------------*/

void addablqexpr( Expr1, Expr2 )

  ablexpr *Expr1;
  ablexpr *Expr2;
{
  if ( Expr2 == (ablexpr *)0 )
  {
    AblQueueExpr = Expr1; return;
  }

  if ( Expr1 == (ablexpr *)0 )
  {
    Expr1 = AblQueueExpr;
  }
  else
  {
    while ( ABL_CDR( Expr1 ) != (ablexpr *)0 )
    {
      Expr1 = ABL_CDR( Expr1 );
    }
  }

  AblQueueExpr     = addchain( (ablexpr *)0, (void *)Expr2 );
  ABL_CDR( Expr1 ) = AblQueueExpr;
}

/*------------------------------------------------------------\
|                                                             |
|                       Add Abl Head Expr                     |
|                                                             |
\------------------------------------------------------------*/

void addablhexpr( Expr1, Expr2 )

  ablexpr *Expr1;
  ablexpr *Expr2;
{
  ABL_CDR( Expr1 ) = addchain( ABL_CDR( Expr1 ), (void *)Expr2 );
}
