/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Abl                           |
|                                                             |
| File    :                   ablenv.c                        |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H

# include <stdio.h>
# include "ablis.h"
# include "ablenv.h"
# include "ablerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char *ABL_OPERATOR_NAME[ ABL_MAX_OPERATOR ];

  char *ABL_OPERATOR_UPPER_NAME[ ABL_MAX_OPERATOR ] =
  {
    "OR",     /*  ABL_OR      */
    "AND",    /*  ABL_AND     */
    "XOR",    /*  ABL_XOR     */
    "NOT",    /*  ABL_NOT     */
    "NOR",    /*  ABL_NOR     */
    "NAND",   /*  ABL_NAND    */
    "NXOR",   /*  ABL_NXOR    */
    "STABLE", /*  ABL_STABLE  */
    "AF",     /*  ABL_AF      */
    "AG",     /*  ABL_AG      */
    "AX",     /*  ABL_AX      */
    "AU",     /*  ABL_AU      */
    "EF",     /*  ABL_EF      */
    "EG",     /*  ABL_EG      */
    "EX",     /*  ABL_EX      */
    "EU"      /*  ABL_EU      */
  };

  char *ABL_ATOM_NAME_ONE;
  char *ABL_ATOM_NAME_ZERO;
  char *ABL_ATOM_NAME_DC;
  char *ABL_ATOM_NAME_TRISTATE;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                           Abl Env                           |
|                                                             |
\------------------------------------------------------------*/

void ablenv()
{
  int Index;

  ABL_ATOM_NAME_ZERO     = namealloc( "'0'" );
  ABL_ATOM_NAME_ONE      = namealloc( "'1'" );
  ABL_ATOM_NAME_DC       = namealloc( "'d'" );
  ABL_ATOM_NAME_TRISTATE = namealloc( "'z'" );

  for ( Index = 0; Index < ABL_MAX_OPERATOR; Index++ )
  {
    ABL_OPERATOR_NAME[ Index ] = namealloc( ABL_OPERATOR_UPPER_NAME[ Index ] );
  }
}
