/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Abl                           |
|                                                             |
| File    :                  ablsubst.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H

# include <stdio.h>
# include "ablsubst.h"
# include "ablerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  static char       *AblSubstName = (char *)0;
  static ablexpr *AblSubstExpr = (ablexpr *)0;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    Substitue Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                Substitue Local Name By Expr                 |
|                                                             |
\------------------------------------------------------------*/

static ablexpr *loc_substablexpr( Expr )

  ablexpr *Expr;
{
  ablexpr *ExprSubst;

  ExprSubst = Expr;

  if ( ABL_ATOM( Expr ) )
  {
    if ( ABL_ATOM_VALUE( Expr ) == AblSubstName )
    {
      freechain( Expr );
      ExprSubst = dupablexpr( AblSubstExpr );
    }

    return( ExprSubst );
  }

  while ( ( Expr = ABL_CDR( Expr ) ) )
  {
    ABL_CAR( Expr ) = loc_substablexpr( ABL_CAR( Expr ) );
  }

  return( ExprSubst );
}

/*------------------------------------------------------------\
|                                                             |
|                     Substitue Name Expr                     |
|                                                             |
\------------------------------------------------------------*/

ablexpr *substablexpr( Expr1, Name, Expr2 )

  ablexpr *Expr1;
  char       *Name;
  ablexpr *Expr2;
{
  AblSubstName = namealloc( Name );
  AblSubstExpr = Expr2;
  
  return( loc_substablexpr( Expr1 ) );
}

/*------------------------------------------------------------\
|                                                             |
|          Substitue Local Duplicate Name By Expr             |
|                                                             |
\------------------------------------------------------------*/

static ablexpr *loc_substdupablexpr( Expr )

  ablexpr *Expr;
{
  ablexpr *ExprDup;
  ablexpr *ExprQueue;

  if ( ABL_ATOM( Expr ) )
  {
    if ( ABL_ATOM_VALUE( Expr ) == AblSubstName )
    {
      return( dupablexpr( AblSubstExpr ) );
    }

    return( addchain( (ablexpr *)0, ABL_CAR( Expr ) ) );
  }

  ExprDup = addchain( (ablexpr *)0,
                      (void *)addchain( (ablexpr *)0,
                                        (void *)ABL_OPER( Expr ) ) );
  ExprQueue = ExprDup;

  while ( ( Expr = ABL_CDR( Expr ) ) != (ablexpr *)0 )
  {
    ABL_CDR( ExprQueue ) = 

       addchain( (ablexpr *)0, (void *)loc_substdupablexpr( ABL_CAR( Expr ) ) );

    ExprQueue = ABL_CDR( ExprQueue );
  }

  return( ExprDup );
}

/*------------------------------------------------------------\
|                                                             |
|                     Substitue Duplicate Name Expr           |
|                                                             |
\------------------------------------------------------------*/

ablexpr *substdupablexpr( Expr1, Name, Expr2 )

  ablexpr *Expr1;
  char       *Name;
  ablexpr *Expr2;
{
  AblSubstName = namealloc( Name );
  AblSubstExpr = Expr2;

  return( loc_substdupablexpr( Expr1 ) );
}
