/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Aut                           |
|                                                             |
| File    :                 Aut Errors                        |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <signal.h>
# include MUT_H
# include AUT_H
# include "auterror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Aut Error Function                  |
|                                                             |
\------------------------------------------------------------*/

void aut_error( Error, Text, File, Line )

  int   Error;
  char *Text;
  char *File;
  long  Line;
{
  char *Name;

  Name = mbkstrdup( File );
  Name[ strlen( File ) - 1 ] = '\0';

  fprintf( stderr, "%s%ld ", Name, Line );

  switch( Error )
  {
    case AUT_ALLOC_ERROR :
      fprintf( stderr, "alloc error, can't continue !\n");
    break;

    case AUT_ALLOC_SIZE_ERROR :
      fprintf( stderr, "null size alloc error, can't continue !\n");
    break;

    case AUT_RESIZE_ERROR :
      fprintf( stderr, "resize error, can't continue !\n");
    break;

    case AUT_HASH_SIZE_ERROR :
      fprintf( stderr, "hash table size %ld error !\n", (long)Text );
    break;

    case AUT_HASH_KEY_ERROR :
      fprintf( stderr, "hash key %lx error !\n", (long)Text );
    break;

    case AUT_OPEN_FILE_ERROR :
      fprintf( stderr, "open file %s error !\n", Text );
    break;

    case AUT_CLOSE_FILE_ERROR :
      fprintf( stderr, "close file %s error !\n", Text );
    break;

    default :

      fprintf( stderr, "unknown internal error %d !\n", Error );
  }

  autexit( 1 );
}
