/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Aut                           |
|                                                             |
| File    :                 autresize.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H

# include <stdio.h>
# include <malloc.h>
# include <memory.h>
# include <string.h>
# include "autresize.h"
# include "auterror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Resize Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Aut Resize                         |
|                                                             |
\------------------------------------------------------------*/

char *autresize( Source, OldSize, NewSize )

   char         *Source;
   unsigned int  OldSize; 
   unsigned int  NewSize; 
{
  char *Target;

  if ( Source == (char *)0 )
  {
    return( autalloc( NewSize, 0 ) );
  }

  if ( ! ( Target = realloc( Source, NewSize ) ) )
  {
    auterror( AUT_RESIZE_ERROR, (char *)0 );
  }

  if ( NewSize > OldSize )
  {
    memset( Target + OldSize, 0, NewSize - OldSize );
  }

  return( Target );
}
