/*------------------------------------------------------------\
|                                                             |
| Tool    :                     B2F                           |
|                                                             |
| File    :                  b2f_error.c                      |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   01.11.94                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>
# include MUT_H
# include AUT_H
# include "b2f_error.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Private variables                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       B2fDisplayError                       |
|                                                             |
\------------------------------------------------------------*/

void B2fDisplayError( File, Line, Error, Text )

   char *File;
   int   Line;
   int   Error;
   char *Text;
{
  char *Name;

  Name = mbkstrdup( File );
  Name[ strlen( File ) - 1 ] = '\0';

  fprintf( stderr, "%s%d ", Name, Line );

  switch( Error )
  {
    case B2F_ILLEGAL_RESET_CONDITION :
      fprintf( stderr, "Illegal reset condition %s\n", Text );
    break;
    case B2F_REGISTER_NOT_A_VECTOR   :
      fprintf( stderr, "Register %s is not a vector\n", Text );
    break;
    case B2F_BAD_CONDITION_REGISTER  :
      fprintf( stderr, "Register %s has a bad clock condition\n", Text );
    break;
    case B2F_BAD_REGISTER_NAME  :
      fprintf( stderr, "All registers should have the same name %s\n", Text );
    break;
    case B2F_NO_REGISTER             :
      fprintf( stderr, "No register in figure %s\n", Text );
    break;
    case B2F_BAD_INITIAL_STRING      :
      fprintf( stderr, "Initial string %s is invalid\n", Text );
    break;
    default : fprintf( stderr, "Internal error number %d\n", Error );
  }

  autexit( 1 );
}

/*------------------------------------------------------------\
|                                                             |
|                       B2fDisplayWarning                     |
|                                                             |
\------------------------------------------------------------*/

void B2fDisplayWarning( File, Line, Warning, Text )

   char *File;
   int   Line;
   int   Warning;
   char *Text;
{
  char *Name;

  Name = mbkstrdup( File );
  Name[ strlen( File ) - 1 ] = '\0';

  fprintf( stderr, "%s%d ", Name, Line );

  switch ( Warning )
  {
    default : fprintf( stderr, "Internal warning number %d\n", Warning );
  }
}
