/*------------------------------------------------------------\
|                                                             |
| Tool    :                     B2F                           |
|                                                             |
| File    :                 b2f_error.h                       |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   01.11.94                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef B2F_ERROR_H
# define B2F_ERROR_H

/*------------------------------------------------------------\
|                                                             |
|                           Errors                            |
|                                                             |
\------------------------------------------------------------*/

# define B2F_ILLEGAL_RESET_CONDITION 1
# define B2F_REGISTER_NOT_A_VECTOR   2
# define B2F_BAD_CONDITION_REGISTER  3
# define B2F_NO_REGISTER             4
# define B2F_BAD_INITIAL_STRING      5
# define B2F_BAD_REGISTER_NAME       6

/*------------------------------------------------------------\
|                                                             |
|                           Warnings                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Macro                            |
|                                                             |
\------------------------------------------------------------*/

# define B2fError( ERROR, TEXT )                             \
                                                             \
    B2fDisplayError( __FILE__, __LINE__, (ERROR), (TEXT) )

# define B2fWarning( WARNING, TEXT )                         \
                                                             \
    B2fDisplayWarning( __FILE__, __LINE__, (WARNING), (TEXT) )

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

# endif
