/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Bdd                           |
|                                                             |
| File    :                   bddfree.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Bddhor  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H

# include <stdio.h>
# include "bddfree.h"
# include "bdderror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Bdd Free User Func                  |
|                                                             |
\------------------------------------------------------------*/

void freebdduserfunc( BddUserFunc )

  bdduserfunc *BddUserFunc;
{
  autfreeheap( (char *)BddUserFunc, sizeof( bdduserfunc ) );
}

/*------------------------------------------------------------\
|                                                             |
|                         Bdd Free Heath                      |
|                                                             |
\------------------------------------------------------------*/

void freebddheath( BddHeath )

  bddheath *BddHeath;
{
  autfreeheap( (char *)BddHeath, sizeof( bddheath ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Bdd Free Hash Node                   |
|                                                             |
\------------------------------------------------------------*/

void freebddhnode( HashNode )

  bddhnode *HashNode;
{
  autfreeblock( (char *)HashNode );
}

/*------------------------------------------------------------\
|                                                             |
|                        Bdd Free Hash Oper                   |
|                                                             |
\------------------------------------------------------------*/

void freebddhoper( HashOper )

  bddhoper *HashOper;
{
  autfreeblock( (char *)HashOper );
}

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Free Hash Node Table                |
|                                                             |
\------------------------------------------------------------*/

void freebddhnodetable( HashTable )

  bddhnodetable *HashTable;
{
  autfreeheap( (char *)HashTable, sizeof( bddhnodetable ) );
}

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Free Hash Oper Table                |
|                                                             |
\------------------------------------------------------------*/

void freebddhopertable( HashTable )

  bddhopertable *HashTable;
{
  autfreeblock( (char *)HashTable );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Free BLock                        |
|                                                             |
\------------------------------------------------------------*/

void freebddblock( BddBlock )

  bddblock *BddBlock;
{
  autfreeheap( (char *)BddBlock, sizeof( bddblock ) );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Free Node Block                   |
|                                                             |
\------------------------------------------------------------*/

void freebddnodeblock( BddNode )

  bddnode *BddNode;
{
  autfreeblock( (char *)BddNode );
}

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Free Variable Node                  |
|                                                             |
\------------------------------------------------------------*/

void freebddvarnode( BddVariableNode )

  bddvarnode *BddVariableNode;
{
  autfreeblock( (char *)BddVariableNode );
}

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Free Hash Variable Node             |
|                                                             |
\------------------------------------------------------------*/

void freebddindexnode( BddIndexNode )

  bddindexnode *BddIndexNode;
{
  autfreeblock( (char *)BddIndexNode );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Free Variable                     |
|                                                             |
\------------------------------------------------------------*/

void freebddvar( BddVariable )

  bddvar *BddVariable;
{
  autfreeblock( (char *)BddVariable );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Free Index                        |
|                                                             |
\------------------------------------------------------------*/

void freebddindex( BddIndex )

  bddindex *BddIndex;
{
  autfreeblock( (char *)BddIndex );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Free Assoc                        |
|                                                             |
\------------------------------------------------------------*/

void freebddassoc( BddAssoc )

  bddassoc *BddAssoc;
{
  autfreeheap( (char *)BddAssoc, sizeof( BddAssoc ) );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Free Assoc Node                   |
|                                                             |
\------------------------------------------------------------*/

void freebddassocnode( BddAssocNode )

  bddassocnode *BddAssocNode;
{
  autfreeblock( (char *)BddAssocNode );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Free Name Input                   |
|                                                             |
\------------------------------------------------------------*/

void freebddnamein( NameIn )

  bddnamein *NameIn;
{
  autfreeblock( (char *)NameIn );
}

/*------------------------------------------------------------\
|                                                             |
|                      Bdd Free Index Input                   |
|                                                             |
\------------------------------------------------------------*/

void freebddindexin( IndexIn )

  bddindex *IndexIn;
{
  autfreeblock( (char *)IndexIn );
}

/*------------------------------------------------------------\
|                                                             |
|                        Bdd Free System                      |
|                                                             |
\------------------------------------------------------------*/

void freebddsystem( BddSystem )

  bddsystem *BddSystem;
{
  autfreeblock( (char *)BddSystem );
}

/*------------------------------------------------------------\
|                                                             |
|                        Bdd Free Circuit                     |
|                                                             |
\------------------------------------------------------------*/

void freebddcircuit( BddCircuit )

  bddcircuit *BddCircuit;
{
  autfreeblock( (char *)BddCircuit );
}
