/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Bdd                           |
|                                                             |
| File    :                 bddreduce.c                       |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H

# include <stdio.h>
# include "bddassoc.h"
# include "bddreduce.h"
# include "bddapply.h"
# include "bddexist.h"
# include "bdderror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                 Local Reduce Bdd Node                       |
|                                                             |
\------------------------------------------------------------*/

static bddnode *loc_reducebdd( BddNode1, BddNode2 )

  bddnode *BddNode1;
  bddnode *BddNode2;
{
  bddhoper *HashOper;
  bddnode  *BddNode;
  bddnode  *BddHigh;
  bddnode  *BddLow;
  bddindex  Index1;
  bddindex  Index2;

  Index1 = BddNode1->INDEX;
  Index2 = BddNode2->INDEX;

  if ( Index2 < BDD_INDEX_MIN )
  {
    if ( Index2 == BDD_INDEX_ZERO )
    {
      return( (bddnode *)0 );
    }

    return( incbddrefext( BddNode1 ) );
  }

  if ( Index1 < BDD_INDEX_MIN )
  {
    return( BddNode1 );
  }

  HashOper = searchbddhoper( BddLocalSystem->HASH_OPER,
                             BDD_OPER_REDUCE, BddNode1, BddNode2 );
 
  if ( HashOper != (bddhoper *)0 )
  {
    return( incbddrefext( HashOper->FATHER ) );
  }

  if ( BddLocalSystem->INDEX_TO_VAR[ Index1 ] > 
       BddLocalSystem->INDEX_TO_VAR[ Index2 ] )
  {
    BddHigh = loc_applybdd( ABL_OR, BddNode2->HIGH, BddNode2->LOW );
    BddNode = loc_reducebdd( BddNode1, BddHigh );
    decbddrefext( BddHigh );
  }
  else
  {
    if ( Index1 == Index2 )
    {
      BddHigh = loc_reducebdd( BddNode1->HIGH, BddNode2->HIGH );
      BddLow  = loc_reducebdd( BddNode1->LOW , BddNode2->LOW  );
    }
    else
    {
      BddHigh = loc_reducebdd( BddNode1->HIGH, BddNode2 );
      BddLow  = loc_reducebdd( BddNode1->LOW , BddNode2 );
    }
  
    if ( BddHigh == (bddnode *)0 ) BddNode = BddLow;
    else
    if ( BddLow  == (bddnode *)0 ) BddNode = BddHigh;
    else
    BddNode = addbddnode( (bddsystem *)0, Index1,
                          decbddrefext( BddHigh ),
                          decbddrefext( BddLow  ) ); 
  }

  addbddhoper( BddLocalSystem->HASH_OPER, 
               BDD_OPER_REDUCE,
               BddNode1, BddNode2, BddNode );

  return( BddNode );
}

/*------------------------------------------------------------\
|                                                             |
|                        Reduce Bdd Node                      |
|                                                             |
\------------------------------------------------------------*/

bddnode *reducebddnode( BddSystem, BddNode1, BddNode2 )

  bddsystem *BddSystem;
  bddnode   *BddNode1;
  bddnode   *BddNode2;
{
  setbddlocalsystem( BddSystem );

  BddNode1 = loc_reducebdd( BddNode1, BddNode2 );

  if ( BddNode1 == (bddnode *)0 )
  {
    BddNode1 = BddLocalSystem->ZERO;
  }

  checkbddmaxnode( (bddsystem *)0, 1 );

  return( BddNode1 );
}

