/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Bdd                           |
|                                                             |
| File    :                  bddresize.c                      |
|                                                             |
| Date    :                   03.12.96                        |
|                                                             |
| Bddhor  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H

# include <stdio.h>
# include "bddresize.h"
# include "bdderror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Resize Variable Node                |
|                                                             |
\------------------------------------------------------------*/

bddvarnode *resizebddvarnode( BddVarNode, OldNum, NewNum )

  bddvarnode *BddVarNode;
  long        OldNum;
  long        NewNum;
{
  BddAllocInfo.VAR_NODE += NewNum - OldNum;

  return( (bddvarnode *)autresizeblock( (char *)BddVarNode,
                                        sizeof( bddvarnode ) * OldNum,
                                        sizeof( bddvarnode ) * NewNum ) );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Resize Variable                   |
|                                                             |
\------------------------------------------------------------*/

bddvar *resizebddvar( BddVar, OldNum, NewNum )

  bddvar *BddVar;
  long    OldNum;
  long    NewNum;
{
  BddAllocInfo.VAR += NewNum - OldNum;

  return( (bddvar *)autresizeblock( (char *)BddVar,
                                    sizeof( bddvar ) * OldNum,
                                    sizeof( bddvar ) * NewNum ) );
}

/*------------------------------------------------------------\
|                                                             |
|                    Bdd Resize Index Node                    |
|                                                             |
\------------------------------------------------------------*/

bddindexnode *resizebddindexnode( BddIndexNode, OldNum, NewNum )

  bddindexnode *BddIndexNode;
  long          OldNum;
  long          NewNum;
{
  BddAllocInfo.INDEX_NODE += NewNum - OldNum;

  return( (bddindexnode *)autresizeblock( (char *)BddIndexNode,
                                          sizeof( bddindexnode ) * OldNum,
                                          sizeof( bddindexnode ) * NewNum ) );
}

/*------------------------------------------------------------\
|                                                             |
|                       Bdd Resize Index                      |
|                                                             |
\------------------------------------------------------------*/

bddindex *resizebddindex( BddIndex, OldNum, NewNum )

  bddindex *BddIndex;
  long      OldNum;
  long      NewNum;
{
  BddAllocInfo.INDEX += NewNum - OldNum;

  return( (bddindex *)autresizeblock( (char *)BddIndex,
                                      sizeof( bddindex ) * OldNum,
                                      sizeof( bddindex ) * NewNum ) );
}

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Resize Assoc Node                   |
|                                                             |
\------------------------------------------------------------*/

bddassocnode *resizebddassocnode( BddAssocNode, OldNum, NewNum )

  bddassocnode *BddAssocNode;
  long          OldNum;
  long          NewNum;
{
  BddAllocInfo.ASSOC_NODE += NewNum - OldNum;

  return( (bddassocnode *)autresizeblock( (char *)BddAssocNode,
                                          sizeof( bddassocnode ) * OldNum,
                                          sizeof( bddassocnode ) * NewNum ) );
}

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Resize Name Input                   |
|                                                             |
\------------------------------------------------------------*/

bddnamein *resizebddnamein( NameIn, OldNum, NewNum )

  bddnamein *NameIn;
  long       OldNum;
  long       NewNum;
{
  BddAllocInfo.NAME_IN += NewNum - OldNum;

  return( (bddnamein *)autresizeblock( (char *)NameIn,
                                       sizeof( bddnamein ) * OldNum,
                                       sizeof( bddnamein ) * NewNum ) );
}

/*------------------------------------------------------------\
|                                                             |
|                     Bdd Resize Index Input                  |
|                                                             |
\------------------------------------------------------------*/

bddindex *resizebddindexin( IndexIn, OldNum, NewNum )

  bddindex *IndexIn;
  long      OldNum;
  long      NewNum;
{
  BddAllocInfo.INDEX_IN += NewNum - OldNum;

  return( (bddindex *)autresizeblock( (char *)IndexIn,
                                      sizeof( bddindex ) * OldNum,
                                      sizeof( bddindex ) * NewNum ) );
}
