/*------------------------------------------------------------\
|                                                             |
| Tool    :                     FSM                           |
|                                                             |
| File    :                   fkserror.c                      |
|                                                             |
| Author  :                 Jacomme Ludovic                   |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H

# include "fkserror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

void fks_error( Error, Text, File, Line )

    char  Error;
    char *Text;
    char *File;
    long  Line;
{
  char *Name;

  Name = mbkstrdup( File );
  Name[ strlen( File ) - 1 ] = '\0';

  fprintf( stderr, "%s%ld ", Name, Line );

  switch ( Error )
  {
    case KISS_ERROR_OPEN_FILE : 

      fprintf( stderr, "unable to open file \"%s\"\n", Text );

    break;

    case KISS_ERROR_PARSE     :

      fprintf( stderr, "parse error line %ld\n", (long)Text );

    break;

    case KISS_ERROR_END       :

      fprintf( stderr, "unexpected end of file line %ld\n", (long)Text );

    break;

    case KISS_ERROR_VALUE     :

      fprintf( stderr, "bad value line %ld\n", (long)Text );

    break;

    case KISS_ERROR_NAME      :

      fprintf( stderr, "bad name line %ld\n", (long)Text );

    break;

    case KISS_ERROR_PORT      :

      fprintf( stderr, "missing port(s) declaration line %ld\n", (long)Text );

    break;

    case KISS_ERROR_STATE     :

      fprintf( stderr, "missing state(s) declaration line %ld\n", (long)Text );

    break;

    case KISS_ERROR_FSM_STACK :

      fprintf( stderr, "unable to drive FSM stack of \"%s\"\n", Text );

    break;


    default :

      fprintf( stderr, "unknown internal error %d !\n", Error );
  }

  autexit( 1 );
}
