/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Fsm                           |
|                                                             |
| File    :                  fsmalloc.c                       |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H

# include <stdio.h>
# include <string.h>
# include "fsmalloc.h"
# include "fsmerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  fsmfig_list *HEAD_FSMFIG = (fsmfig_list *)0;

  char *FSM_CTRL_NAME [ FSM_MAX_CTRL ] =
  {
    "NOP", "PUSH", "POP"
  };

  char *FSM_TYPE_NAME [ FSM_MAX_TYPE ] =
  {
    "NONE",
    "SEVERITY",
    "BOOLEAN",
    "BIT",
    "INTEGER",
    "MUX_BIT",
    "WOR_BIT",
    "REG_BIT",
    "NATURAL",
    "BIT_VEC",
    "MUX_VEC",
    "WOR_VEC",
    "REG_VEC"
  };

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Alloc Functions                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Fsm Alloc Figure                     |
|                                                             |
\------------------------------------------------------------*/
 
fsmfig_list *allocfsmfig()
{
  return( (fsmfig_list *)(autallocblock( sizeof( fsmfig_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                         Fsm Alloc State                     |
|                                                             |
\------------------------------------------------------------*/

fsmstate_list *allocfsmstate()
{
  return( (fsmstate_list *)(autallocheap( sizeof( fsmstate_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                         Fsm Alloc Stack                     |
|                                                             |
\------------------------------------------------------------*/

fsmstack_list *allocfsmstack()
{
  return( (fsmstack_list *)(autallocheap( sizeof( fsmstack_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                      Fsm Alloc Transition                   |
|                                                             |
\------------------------------------------------------------*/

fsmtrans_list *allocfsmtrans()
{
  return( (fsmtrans_list *)(autallocheap( sizeof( fsmtrans_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                     Fsm Alloc Local Output                  |
|                                                             |
\------------------------------------------------------------*/

fsmlocout_list *allocfsmlocout()
{
  return( (fsmlocout_list *)(autallocheap( sizeof( fsmlocout_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Alloc Input                      |
|                                                             |
\------------------------------------------------------------*/

fsmin_list *allocfsmin()
{
  return( (fsmin_list *)(autallocblock( sizeof( fsmin_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Alloc Output                     |
|                                                             |
\------------------------------------------------------------*/

fsmout_list *allocfsmout()
{
  return( (fsmout_list *)(autallocblock( sizeof( fsmout_list ) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Alloc Port                       |
|                                                             |
\------------------------------------------------------------*/

fsmport_list *allocfsmport()
{
  return( (fsmport_list *)(autallocblock( sizeof( fsmport_list ) ) ) );
}
