/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Fsm                           |
|                                                             |
| File    :                  fsmfree.c                        |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H

# include <stdio.h>
# include <string.h>
# include "fsmfree.h"
# include "fsmalloc.h"
# include "fsmerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     Fsm Free Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Fsm Free Figure                        |
|                                                             |
\------------------------------------------------------------*/
 
void freefsmfig( Figure )

  fsmfig_list *Figure;
{
  autfreeblock( (char *)Figure );
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Free State                       |
|                                                             |
\------------------------------------------------------------*/

void freefsmstate( State )

  fsmstate_list *State;
{
  autfreeheap( (char *)State, sizeof( fsmstate_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Free Stack                       |
|                                                             |
\------------------------------------------------------------*/

void freefsmstack( Stack )

  fsmstack_list *Stack;
{
  autfreeheap( (char *)Stack, sizeof( fsmstack_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Free Trans                       |
|                                                             |
\------------------------------------------------------------*/

void freefsmtrans( Trans )

  fsmtrans_list *Trans;
{
  autfreeheap( (char *)Trans, sizeof( fsmtrans_list ));
}


/*------------------------------------------------------------\
|                                                             |
|                    Fsm Free Local Output                    |
|                                                             |
\------------------------------------------------------------*/

void freefsmlocout( Locout )

  fsmlocout_list *Locout;
{
  autfreeheap( (char *)Locout, sizeof( fsmlocout_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Free Output                      |
|                                                             |
\------------------------------------------------------------*/

void freefsmout( Output )

  fsmout_list *Output;
{
  autfreeblock( (char *)Output );
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Free Input                       |
|                                                             |
\------------------------------------------------------------*/

void freefsmin( Input )

  fsmin_list *Input;
{
  autfreeblock( (char *)Input  );
}

/*------------------------------------------------------------\
|                                                             |
|                        Fsm Free Port                        |
|                                                             |
\------------------------------------------------------------*/

void freefsmport( Port )

  fsmport_list *Port;
{
  autfreeblock( (char *)Port );
}
