/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Ftl                           |
|                                                             |
| File    :                  ftlacces.c                       |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include FTL_H

# include "ftlacces.h"
# include "ftlerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char *FSM_IN;
  char *FSM_OUT;

  char *FSM_KISS_FORMAT = (char *)0;
  char *FSM_VHDL_FORMAT = (char *)0;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            fsmenv                           |
|                                                             |
\------------------------------------------------------------*/

void fsmenv()
{
  FSM_IN = namealloc( getenv( "FSM_IN") );

  if ( FSM_IN == (char *)0 )
  {
    FSM_IN = namealloc( FTL_DEFAULT_IN );
  }
 
  FSM_OUT = namealloc( getenv( "FSM_OUT") );

  if ( FSM_OUT == (char *)0 )
  {
    FSM_OUT = namealloc( FTL_DEFAULT_OUT );
  }

  FSM_KISS_FORMAT = namealloc( "kiss2" );
  FSM_VHDL_FORMAT = namealloc( "fsm"   );
}

/*------------------------------------------------------------\
|                                                             |
|                          loadfsmfig                         |
|                                                             |
\------------------------------------------------------------*/

void loadfsmfig( Figure, Name )

  fsmfig_list *Figure;
  char        *Name;
{
  if ( FSM_IN == FSM_KISS_FORMAT ) 
  {
    kissloadfsmfig( Figure, Name );
  }
  else
  if ( FSM_IN == FSM_VHDL_FORMAT )
  {
    vhdlloadfsmfig( Figure, Name );
  }
  else
  {
    ftlerror( FTL_UNKNOWN_FSM_IN, FSM_IN );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                          savefsmfig                         |
|                                                             |
\------------------------------------------------------------*/

void savefsmfig( Figure )

  fsmfig_list *Figure;
{
  if ( FSM_OUT == FSM_KISS_FORMAT )
  {
    kisssavefsmfig( Figure );
  }
  else
  if ( FSM_OUT == FSM_VHDL_FORMAT )
  {
    vhdlsavefsmfig( Figure );
  }
  else
  {
    ftlerror( FTL_UNKNOWN_FSM_OUT, FSM_OUT );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                          getfsmfig                          |
|                                                             |
\------------------------------------------------------------*/

fsmfig_list *getfsmfig( Name )

   char *Name;
{
  fsmfig_list *Figure;

  Name = namealloc( Name );

  for ( Figure  = HEAD_FSMFIG;
        Figure != (fsmfig_list *)0;
        Figure  = Figure->NEXT )
  {
    if ( Figure->NAME == Name ) break;
  }

  if ( Figure == (fsmfig_list *)0 )
  {
    Figure = addfsmfig( Name );

    loadfsmfig( Figure, Name );
  }

  return( Figure );
}
