/***************************************************************************
* Fonctions utiles pour fbfig : optimisation des abl d'un fbfig, evaluation *
* du cout . . .                               *
*           Le 01/09/92.
****************************************************************************/
#include <stdio.h>
#include MUT_H
#include AUT_H
#include ABL_H
#include BDD_H
#include FVH_H

/*------------------------------------------------------------------------i
fsp_mapCarExprFbh  : applique une fonction de conversion sur chaque expression
                  d'une fbfig 
---------------------------------------------------------------------------
retour    : un void.
---------------------------------------------------------------------------*/
void fsp_mapCarExprFbh(fbh,func)

fbfig_list *fbh;
chain_list *(*func)();
{
fbout_list *out;
fbreg_list *reg;
fbbus_list *bus;
fbbux_list *bux;
biabl_list *biabl;
fbaux_list *aux;


aux = fbh->BEAUX;
while (aux) 
   {
   if (aux->ABL)
      {
      aux->ABL = (*func)(aux->ABL);
      }
   aux = aux->NEXT;
   }

out = fbh->BEOUT;
while (out) 
   {
   if (out->ABL)
      {
      out->ABL = (*func)(out->ABL);
      }
   out = out->NEXT;
   }

reg = fbh->BEREG;
while (reg) 
   {
   biabl = reg->BIABL;
   while (biabl)
      {
      if (biabl->CNDABL && biabl->VALABL)
         {
         biabl->CNDABL = (*func)(biabl->CNDABL);
         biabl->VALABL = (*func)(biabl->VALABL);
         }
      biabl = biabl->NEXT;
      }
   reg = reg->NEXT;
   }

bus = fbh->BEBUS;
while (bus) 
   {
   biabl = bus->BIABL;
   while (biabl)
      {
      if (biabl->CNDABL && biabl->VALABL)
         {
         biabl->CNDABL = (*func)(biabl->CNDABL);
         biabl->VALABL = (*func)(biabl->VALABL);
         }
      biabl = biabl->NEXT;
      }
   bus = bus->NEXT;
   }

bux = fbh->BEBUX;
while (bux) 
   {
   biabl = bux->BIABL;
   while (biabl)
      {
      if (biabl->CNDABL && biabl->VALABL)
         {
         biabl->CNDABL = (*func)(biabl->CNDABL);
         biabl->VALABL = (*func)(biabl->VALABL);
         }
      biabl = biabl->NEXT;
      }
   bux = bux->NEXT;
   }
}

/*-----------------------------------------------------------------------
fbrinToChain_list : forme une chaine liste des entrees.
          prend l'odre d'apparition.
-----------------------------------------------------------------------
parametres        : fbh.
---------------------------------------------------------------------------
retour      : un pointeur de chain_list.
---------------------------------------------------------------------------*/
chain_list *fbrinToChain_list(fbh)
fbfig_list *fbh;
{
fbrin_list *in;
chain_list *lst;
 
in = fbh->BERIN;    /* entrees primaires */
lst = 0;

while (in)
  {
     lst = addchain(lst,(void *)in->NAME);
   in = in->NEXT;
   };
  
  return(lst);
}

/*-------------------------------------------------------------------------
fsp_countInputFbh   : compte les entrees d'un circuit (fbrin)
---------------------------------------------------------------------------
retour    : un int.
---------------------------------------------------------------------------*/

int fsp_countInputFbh(fbh)
fbfig_list *fbh;
{
fbrin_list *in;
int count = 0;

in = fbh->BERIN;  /* entrees primaires */
while (in)
   {
   in = in->NEXT;
   count++;
   };

return(count);
}
