/*------------------------------------------------------------\
|                                                             |
| Tool    :                     K2F                           |
|                                                             |
| File    :                  k2f_main.c                       |
|                                                             |
| Author  :                 Jacomme Ludovic                   |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include FTL_H

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include "k2f_error.h"
# include "k2f_main.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

   fsmfig_list *K2fFsmFigure = (fsmfig_list    *)0;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          K2f Usage                          |
|                                                             |
\------------------------------------------------------------*/

void K2fUsage()
{
  fprintf( stderr, "\t\tk2f In_format Out_format Input_name [Output_name]\n\n" );
  fprintf( stdout, "\n" );

  exit( 1 );
}

/*------------------------------------------------------------\
|                                                             |
|                            Main                             |
|                                                             |
\------------------------------------------------------------*/

int main( argc, argv )

   int   argc;
   char *argv[];
{
  char  *InputFileName;
  char  *OutputFileName;
  char  *InputFormat;
  char  *OutputFormat;
  int    Number;

  alliancebanner_with_authors( "K2F", K2F_VERSION,
      "Translator Kiss <-> FSM Format", "1996", ALLIANCE_VERSION,
      "Ludovic Jacomme" );

  mbkenv();
  autenv();
  ablenv();
  bddenv();
  fsmenv();

  if ( argc < 4 ) K2fUsage();

  InputFileName  = (char *)0;
  OutputFileName = (char *)0;
  InputFormat    = (char *)0;
  OutputFormat   = (char *)0;

  for ( Number = 1; Number  < argc; Number++ )
  {
    if ( InputFormat    == (char *)0 ) InputFormat   = argv[ Number ];
    else
    if ( OutputFormat   == (char *)0 ) OutputFormat  = argv[ Number ];
    else
    if ( InputFileName  == (char *)0 ) InputFileName = argv[ Number ];
    else
    if ( OutputFileName == (char *)0 ) OutputFileName = argv[ Number ];
    else
    K2fUsage();
  }

  if ( ( InputFileName  == (char *)0 ) ||
       ( InputFormat    == (char *)0 ) ||
       ( OutputFormat   == (char *)0 ) ) K2fUsage();

  if ( OutputFileName == (char *)0 ) OutputFileName = InputFileName;

  FSM_IN  = namealloc( InputFormat  );
  FSM_OUT = namealloc( OutputFormat );

  fprintf( stdout, "\n\n\t--> Translate figure %s\n", InputFileName );

  K2fFsmFigure = getfsmfig( InputFileName );

  K2fFsmFigure->NAME = namealloc( OutputFileName );
  savefsmfig( K2fFsmFigure );

  fprintf( stdout, "\t<-- done\n\n" );

  return( 0 );
}
