/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Scg                           |
|                                                             |
| File    :                    scglo.c                        |
|                                                             |
| Date    :                   28.04.98                        |
|                                                             |
| Authors :               Picault  Stephane                   |
|                         Miramond   Benoit                   |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include SCL_H
# include MLO_H

# include <stdio.h>
# include "scg.h"
# include "scglo.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                          Get Sch Figure From Lo fig         |
|                                                             |
\------------------------------------------------------------*/


schfig_list *getschfig_from_lofig( FileName )

   char *FileName;
{
  lofig_list   *LoFigure;
  locon_list   *LoCon;
  loins_list   *LoIns;
  losig_list   *LoSig;
  schcon_list  *SchCon;
  schbox_list  *SchBox;
  schnet_list  *SchNet;
  schfig_list  *SchFigure;
  ptype_list   *PType;
  unsigned char SchDir;

  LoFigure  = getlofig( FileName, 'A' );
  SchFigure = addschfig( LoFigure->NAME );
  SchFigure->SOURCE = (void *)LoFigure;
  SchFigure->SOURCE_TYPE = SCH_SOURCE_LOFIG;

  for ( LoSig  = LoFigure->LOSIG;
        LoSig != (losig_list *)0;
        LoSig  = LoSig->NEXT )
  {
    SchNet = addschnet( SchFigure );
    SchNet->SOURCE = (void *)LoSig;
    SchNet->SOURCE_TYPE = SCH_SOURCE_LOSIG ;

    LoSig->USER = addptype( LoSig->USER, SCH_NET_TYPE, SchNet );
  }

  for ( LoCon  = LoFigure->LOCON;
        LoCon != (locon_list *)0;
        LoCon  = LoCon->NEXT )
  {
    if ( !((isvdd(LoCon->NAME)) || (isvss(LoCon->NAME))) )
    {
      if ( LoCon->DIRECTION == IN ) SchDir = SCH_CON_IN;
      else                          SchDir = SCH_CON_OUT;

      SchCon = addschfigcon( SchFigure, LoCon->NAME, SchDir );

      SchCon->SOURCE = (void *)LoCon;
      SchCon->SOURCE_TYPE = SCH_SOURCE_LOCON;

    
      LoSig  = LoCon->SIG;
      PType  = getptype( LoSig->USER, SCH_NET_TYPE );
      SchNet = (schnet_list *)PType->DATA;

      addschnetcon( SchNet, SchCon);
    }
  }

  for ( LoIns  = LoFigure->LOINS;
        LoIns != (loins_list *)0;
        LoIns  = LoIns->NEXT )
  {
    SchBox = addschbox( SchFigure, LoIns->INSNAME );
    SchBox->SOURCE = (void *)LoIns;
    SchBox->SOURCE_TYPE = SCH_SOURCE_LOINS;

    for ( LoCon  = LoIns->LOCON;
          LoCon != (locon_list *)0;
          LoCon  = LoCon->NEXT )
    {
      if ( !((isvdd(LoCon->NAME)) || (isvss(LoCon->NAME))) )
      {
         if ( LoCon->DIRECTION == IN ) SchDir = SCH_CON_IN;
         else                          SchDir = SCH_CON_OUT;

         SchCon = addschboxcon( SchFigure, SchBox, LoCon->NAME, SchDir );
         SchCon->SOURCE = (void *)LoCon;
         SchCon->SOURCE_TYPE = SCH_SOURCE_LOCON;
      

         LoSig  = LoCon->SIG;
         PType  = getptype( LoSig->USER, SCH_NET_TYPE );
         SchNet = (schnet_list *)PType->DATA;

	 addschnetcon(SchNet,SchCon);
      }
    }
  }

  for ( LoSig  = LoFigure->LOSIG;
        LoSig != (losig_list *)0;
        LoSig  = LoSig->NEXT )
  {
    LoSig->USER = delptype( LoSig->USER, SCH_NET_TYPE );
  }

  return( SchFigure );
}
