/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Sch                           |
|                                                             |
| File    :                   schdel.c                        |
|                                                             |
| Date    :                   04.03.98                        |
|                                                             |
| Authors :               Picault  Stephane                   |
|                         Miramond   Benoit                   |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include SCL_H

# include <stdio.h>
# include "schdel.h"
# include "scherror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Sch Del Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Sch Del Connector List               |
|                                                             |
\------------------------------------------------------------*/

static void loc_delschcon( HeadCon )
  
   schcon_list *HeadCon;
{
  schcon_list *ScanCon;
  schcon_list *DelCon;

  ScanCon = HeadCon;
  
  while ( ScanCon != (schcon_list *)0 )
  {
    DelCon  = ScanCon;
    ScanCon = ScanCon->NEXT;
    
    freeschcon( DelCon );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                        Sch Del Wire List                    |
|                                                             |
\------------------------------------------------------------*/

static void loc_delschwir( HeadWire )
  
   schwir_list *HeadWire;
{
  schwir_list *ScanWire;
  schwir_list *DelWire;

  ScanWire = HeadWire;
  
  while ( ScanWire != (schwir_list *)0 )
  {
    DelWire  = ScanWire;
    ScanWire = ScanWire->NEXT;
    
    freeschwir( DelWire );
  }
}


/*------------------------------------------------------------\
|                                                             |
|                        Sch Del Net List                     |
|                                                             |
\------------------------------------------------------------*/

static void loc_delschnet( HeadNet )
  
   schnet_list *HeadNet;
{
  schnet_list *ScanNet;
  schnet_list *DelNet;

  ScanNet = HeadNet;
  
  while ( ScanNet != (schnet_list *)0 )
  {
    DelNet  = ScanNet;
    ScanNet = ScanNet->NEXT;
    
    loc_delschwir( DelNet->WIRE );

    if ( DelNet->CON_NET != (chain_list *)0 )
    {
      freechain( DelNet->CON_NET );
    }
    
    freeschnet( DelNet );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                        Sch Del Box List                     |
|                                                             |
\------------------------------------------------------------*/

static void loc_delschbox( HeadBox )
  
   schbox_list *HeadBox;
{
  schbox_list *ScanBox;
  schbox_list *DelBox;

  ScanBox = HeadBox;
  
  while ( ScanBox != (schbox_list *)0 )
  {
    DelBox  = ScanBox;
    ScanBox = ScanBox->NEXT;
    
    loc_delschcon( DelBox->CON_IN  );
    loc_delschcon( DelBox->CON_OUT );
    
    freeschbox( DelBox );
  }
}

/*------------------------------------------------------------\
|                                                             |
|                        Sch Del Figure                       |
|                                                             |
\------------------------------------------------------------*/

int delschfig( Name )

  char *Name;
{
  schfig_list    *Figure;
  schfig_list   **Previous;

  Name     = namealloc( Name );
  Previous = &HEAD_SCHFIG;

  for ( Figure  = HEAD_SCHFIG;
        Figure != (schfig_list *)0;
        Figure  = Figure->NEXT )
  {
    if ( Figure->NAME == Name ) break;

    Previous = &Figure->NEXT;
  }

  if ( Figure == (schfig_list *)0 ) return( 0 );

  *Previous = Figure->NEXT;

  loc_delschcon( Figure->CON_IN  );
  loc_delschcon( Figure->CON_OUT );

  loc_delschnet( Figure->CON_OUT );
  loc_delschbox( Figure->CON_OUT );

  freeschfig( Figure );

  return( 1 );
}

