/*------------------------------------------------------\
|                                                       |
|  Title   :   Structures and fonctions for SCP         |
|                                                       |
|  File    :              scp.h                         |
|                                                       |
|  Date    :            28.04.98                        |
|                                                       |
|  Authors :         Picault   Stephane                 |
|                    Miramond    Benoit                 |
|                                                       |
\------------------------------------------------------*/

# ifndef SCP_H
# define SCP_H

/*------------------------------------------------------\
|                                                       |
|                      Constants                        |
|                                                       |
\------------------------------------------------------*/

# define SCP_CEL_BOX        0x0001
# define SCP_CEL_CON        0x0002

/*------------------------------------------------------\
|                                                       |
|                        Macros                         |
|                                                       |
\------------------------------------------------------*/

/*------------------------------------------------------\
|                                                       |
|                      Structures                       |
|                                                       |
\------------------------------------------------------*/

/*------------------------------------------------------\
|                                                       |
|                        Colums                         |
|                                                       |
\------------------------------------------------------*/

  typedef struct scpcol_list
  {
    struct scpcol_list  *NEXT;
    struct scpcel_list  *CELL;
    struct scpcel_list  *LAST_CELL;
    long                 NUMBER_CELL;
    long                 MAX_DX_CELL;
  } scpcol_list;

/*------------------------------------------------------\
|                                                       |
|                        Cells                          |
|                                                       |
\------------------------------------------------------*/

  typedef struct scpcel_list
  {
    struct scpcel_list  *NEXT;
    struct scpcel_list  *PREV;
    struct scpcol_list  *COL;
    void                *ROOT;
    long                 TYPE;
  } scpcel_list;

/*------------------------------------------------------\
|                                                       |
|                     Global Variables                  |
|                                                       |
\------------------------------------------------------*/

        scpcol_list   *HEAD_SCPCOL;

/*------------------------------------------------------\
|                                                       |
|                        Functions                      |
|                                                       |
\------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|                    Alloc Functions                    |
|                                                       |
\------------------------------------------------------*/

  extern scpcol_list    *allocscpcol();
  extern scpcel_list    *allocscpcel();

/*------------------------------------------------------\
|                                                       |
|                      Free Functions                   |
|                                                       |
\------------------------------------------------------*/

  extern void  freescpcol();
  extern void  freescpcel();

/*------------------------------------------------------\
|                                                       |
|                      Add Functions                    |
|                                                       |
\------------------------------------------------------*/

  extern scpcel_list    *addscpcel();
  extern scpcol_list    *addscpcol();

  extern scpcel_list    *addschboxtoscpcel();
  extern scpcel_list    *addschcontoscpcel();


/*------------------------------------------------------\
|                                                       |
|                      Del Functions                    |
|                                                       |
\------------------------------------------------------*/

  extern void   delscpcol();

/*------------------------------------------------------\
|                                                       |
|                      Search Functions                 |
|                                                       |
\------------------------------------------------------*/

  extern void   swapscpcel();
  
/*------------------------------------------------------\
|                                                       |
|                     View Functions                    |
|                                                       |
\------------------------------------------------------*/


# endif 
