/*------------------------------------------------------------\
|                                                             |
| Tool    :                     SYF                           |
|                                                             |
| File    :                  syf_tools.c                      |
|                                                             |
| Authors :                  C. Sarwary                       |
|                     Modified by Jacomme Ludovic             |
|                                                             |
| Date    :                   01.11.94                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include "syf_tools.h"
# include "syf_error.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       SyfGetNumberBit                       |
|                                                             |
\------------------------------------------------------------*/

int SyfGetNumberBit( Value )

  long Value;
{
  long Mask;
  int  NumberBit;
  
  Mask = 1 << 31;

  for ( NumberBit = 32; NumberBit > 0; NumberBit-- )
  {
    if ( Mask & Value ) return( NumberBit );

    Mask = Mask >> 1;
  }

  return( 0 );
}

/*------------------------------------------------------------\
|                                                             |
|                     SyfGetHamingDistance                    |
|                                                             |
\------------------------------------------------------------*/

int SyfGetHamingDistance( First, Second, Bits )

  int First;
  int Second;
  int Bits;
{
  register int Mask;
  register int Counter;
  register int Distance;

  First    = First ^ Second;
  Distance = 0;
  Mask     = 1;

  for( Counter = 0; Counter < Bits; Counter++ )
  {
    if( Mask & First ) Distance++;

    Mask = Mask << 1;
  }

  return( Distance );
}

/*------------------------------------------------------------\
|                                                             |
|                     SyfGetNumberBitSet                      |
|                                                             |
\------------------------------------------------------------*/

int SyfGetNumberBitSet( Number, Bits )

  int Number;
  int Bits;
{
  int Mask;
  int Counter;
  int BitSet;

  Mask   = 1;
  BitSet = 0;

  for( Counter = 0; Counter < Bits; Counter++ )
  {
    if( Mask & Number ) BitSet++;

    Mask = Mask << 1;
  }

  return( BitSet );
}
