# include <stdio.h>
# include <malloc.h>

# include MUT_H
# include AUT_H
# include VEX_H
# include VBH_H
# include VBL_H

# ifdef VBL_DEBUG
  extern int vbl_y_debug;
# endif

/*------------------------------------------------------------\
|                                                             |
|                            Usage                            |
|                                                             |
\------------------------------------------------------------*/

void VblUsage()
{
  fprintf( stderr, "\t\tvbltest [Options] Input_name\n\n" );
  fprintf( stdout, "\t\tOptions : -V Sets Verbose mode on\n" );
# ifdef VBL_DEBUG
  fprintf( stdout, "\t\t          -D Sets Debug mode on\n" );
# endif
  fprintf( stdout, "\t\t          -S Simplify Vex\n" );
  fprintf( stdout, "\n" );

  exit( 1 );
}

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

int main( argc, argv )

  int    argc;
  char **argv;
{
  char       *InputFileName;
  int         Number;
  int         Index;
  char        Option;
  vbfig_list *VbhFigure;
  char       *Extention;

  int   FlagVerbose = 0;
# ifdef VBL_DEBUG
  int   FlagDebug   = 0;
# endif
  int   FlagSimplif = 0;

  mbkenv();
  autenv();
  vexenv();

  InputFileName = (char *)0;
  Extention     = "vhdl";

  if ( argc < 2 ) VblUsage();

  InputFileName = (char *)0;

  for ( Number = 1; Number  < argc; Number++ )
  {
    if ( argv[ Number ][ 0 ] == '-' )
    {
      for ( Index = 1; argv[ Number ][ Index ] != '\0'; Index++ )
      {
        Option = argv[ Number ][ Index ];

        if ( Option == 'I' )
        {
          Number++;

          if ( Number < argc ) Extention = argv[ Number ];
          else                 VblUsage();

          break;
        }

        switch ( Option )
        {
          case 'V' : FlagVerbose = 1;
          break;
# ifdef VBL_DEBUG
          case 'D' : FlagDebug = 1;
          break;
# endif
          case 'S' : FlagSimplif = 1;
          break;
          default  : VblUsage();
        }
      }
    }
    else
    if ( InputFileName == (char *)0 ) InputFileName = argv[ Number ];
    else
    VblUsage();
  }

  if ( InputFileName == (char *)0 ) VblUsage();

# ifdef VBL_DEBUG
  if ( FlagDebug ) vbl_y_debug = 1;
# endif

  VbhFigure = getvbfig( InputFileName, Extention );

  if ( FlagSimplif ) vbh_simpvbfig( VbhFigure );
  if ( FlagVerbose ) vbh_viewvbfig( VbhFigure );

  vbh_frevbfig( VbhFigure );

  return( 0 );
}
