/*------------------------------------------------------------\
|                                                             |
| Tool    :                     Vpn                           |
|                                                             |
| File    :                  vpnfree.c                        |
|                                                             |
| Date    :                   04.07.96                        |
|                                                             |
| Author  :               Jacomme Ludovic                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include MUT_H
# include AUT_H
# include VEX_H
# include VPN_H

# include <stdio.h>
# include <string.h>
# include "vpnfree.h"
# include "vpnalloc.h"
# include "vpnerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     Vpn Free Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Vpn Free Figure                        |
|                                                             |
\------------------------------------------------------------*/
 
void freevpnfig( Figure )

  vpnfig_list *Figure;
{
  autfreeblock( (char *)Figure );
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Process                     |
|                                                             |
\------------------------------------------------------------*/

void freevpnproc( Process )

  vpnproc_list *Process;
{
  autfreeheap( (char *)Process, sizeof( vpnproc_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Function                    |
|                                                             |
\------------------------------------------------------------*/

void freevpnfunc( Function )

  vpnfunc_list *Function;
{
  autfreeheap( (char *)Function, sizeof( vpnfunc_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Place                       |
|                                                             |
\------------------------------------------------------------*/

void freevpnplace( Place )

  vpnplace_list *Place;
{
  autfreeheap( (char *)Place, sizeof( vpnplace_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Arc                         |
|                                                             |
\------------------------------------------------------------*/

void freevpnarc( Arc )

  vpnarc *Arc;
{
  autfreeheap( (char *)Arc, sizeof( vpnarc ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Action                      |
|                                                             |
\------------------------------------------------------------*/

void freevpnact( Act )

  vpnact_list *Act;
{
  autfreeheap( (char *)Act, sizeof( vpnact_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Symbol                      |
|                                                             |
\------------------------------------------------------------*/

void freevpnsym( Sym )

  vpnsym *Sym;
{
  autfreeblock( (char *)Sym );
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Declaration                 |
|                                                             |
\------------------------------------------------------------*/

void freevpndecl( Decl )

  vpndecl_list *Decl;
{
  autfreeheap( (char *)Decl, sizeof( vpndecl_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Trans                       |
|                                                             |
\------------------------------------------------------------*/

void freevpntrans( Trans )

  vpntrans_list *Trans;
{
  autfreeheap( (char *)Trans, sizeof( vpntrans_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Attr                        |
|                                                             |
\------------------------------------------------------------*/

void freevpnattr( Attr )

  vpnattr_list *Attr;
{
  autfreeheap( (char *)Attr, sizeof( vpnattr_list ));
}

/*------------------------------------------------------------\
|                                                             |
|                        Vpn Free Line                        |
|                                                             |
\------------------------------------------------------------*/

void freevpnline( Line )

  vpnline_list *Line;
{
  autfreeheap( (char *)Line, sizeof( vpnline_list ));
}
