/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XFSM                            |
|                                                             |
| File    :                   Bdd.c                           |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <signal.h>
# include <string.h>
# include <setjmp.h>
# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include FTL_H
# include XSB_H 
# include XFS_H
# include "XFS_bdd.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                           Functions                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        XfsmMakeBddCircuit                   |
|                                                             |
\------------------------------------------------------------*/

bddcircuit *XfsmMakeBddCircuit( BddSystem, FsmFigure )

  bddsystem   *BddSystem;
  fsmfig_list *FsmFigure;
{
  fsmin_list  *ScanIn;
  fsmout_list *ScanOut;
  bddcircuit  *BddCircuit;

  BddCircuit = createbddcircuit( FsmFigure->NAME,
                                 FsmFigure->NUMBER_IN + FsmFigure->NUMBER_OUT,
                                 FsmFigure->NUMBER_STATE, BddSystem );

  for ( ScanIn  = FsmFigure->IN;
        ScanIn != (fsmin_list *)0;
        ScanIn  = ScanIn->NEXT )
  {
    addbddcircuitin( (bddcircuit *)0, ScanIn->NAME,
                     (bddindex    )0, BDD_IN_MODE_LAST );
  }

  for ( ScanOut  = FsmFigure->OUT;
        ScanOut != (fsmout_list *)0;
        ScanOut  = ScanOut->NEXT )
  {
    addbddcircuitin( (bddcircuit *)0, ScanOut->NAME,
                     (bddindex    )0, BDD_IN_MODE_LAST );
  }

  addbddcircuitin( (bddcircuit *)0, "'d'",
                   (bddindex    )0, BDD_IN_MODE_LAST );

  FsmFigure->CIRCUIT = BddCircuit;

  makefsmbddnode( FsmFigure );

  return( BddCircuit );
}

/*------------------------------------------------------------\
|                                                             |
|                        XfsmSimplifyFigure                   |
|                                                             |
\------------------------------------------------------------*/

void XfsmSimplifyFigure( FsmFigure )

  fsmfig_list *FsmFigure;
{
  bddsystem      *BddSystem;
  bddcircuit     *BddCircuit;

  BddSystem = createbddsystem( XFSM_BDD_VAR_NODE, 
                               XFSM_BDD_OPER_NODE, 1000, XFSM_BDD_MAX_NODE );

  reorderbddsystemdynamic( BddSystem, XFSM_BDD_REORDER_FUNC,
                           XFSM_BDD_REORDER_LOW, XFSM_BDD_REORDER_RATIO );

  BddCircuit = XfsmMakeBddCircuit( BddSystem, FsmFigure );
  convertfsmbddnodeabl( FsmFigure );

  destroybddcircuit( BddCircuit );
  destroybddsystem( BddSystem );

   FsmFigure->CIRCUIT = (bddcircuit *)0;
}
