/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XFSM                            |
|                                                             |
| File    :                  Bound.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include XSB_H
# include XFS_H
# include "XFS_bound.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  long         XfsmBoundXmin   = 0;
  long         XfsmBoundYmin   = 0;
  long         XfsmBoundXmax   = 0;
  long         XfsmBoundYmax   = 0;

  char         XfsmRecomputeBound = XFSM_TRUE; 

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     XfsmComputeBound                       |
|                                                             |
\------------------------------------------------------------*/

char XfsmComputeBound()

{
  xfsmobj_list *Obj;
  short         Layer;
  short         FirstBound;

  if ( XfsmFigure == (xfsmfig_list *)NULL )
  {
    return( XFSM_FALSE );
  }

  if ( XfsmRecomputeBound == XFSM_FALSE )
  {
    return( XFSM_TRUE );
  }

  autbegin();

  FirstBound = 1;

  for ( Layer = 0; Layer < XFSM_MAX_LAYER; Layer++ )
  {
    for ( Obj  = XfsmFigure->OBJECT[ Layer ];
          Obj != (xfsmobj_list *)NULL;
          Obj  = Obj->NEXT )
    {
      if ( FirstBound )
      {
        XfsmBoundXmin   = Obj->X;
        XfsmBoundYmin   = Obj->Y;
        XfsmBoundXmax   = Obj->X + Obj->DX;
        XfsmBoundYmax   = Obj->Y + Obj->DY;
        FirstBound      = 0;
      }
      else
      {
        if ( Obj->X < XfsmBoundXmin )
        {
          XfsmBoundXmin = Obj->X;
        }

        if ( Obj->Y < XfsmBoundYmin )
        {
          XfsmBoundYmin = Obj->Y;
        }

        if ( ( Obj->X + Obj->DX ) > XfsmBoundXmax )
        {
          XfsmBoundXmax = Obj->X + Obj->DX;
        }

        if ( ( Obj->Y + Obj->DY ) > XfsmBoundYmax )
        {
          XfsmBoundYmax = Obj->Y + Obj->DY;
        }
      }
    }
  }

  XfsmBoundXmin = XfsmBoundXmin - ( XFSM_UNIT << 1 );
  XfsmBoundYmin = XfsmBoundYmin - ( XFSM_UNIT << 1 );
  XfsmBoundXmax = XfsmBoundXmax + ( XFSM_UNIT << 1 );
  XfsmBoundYmax = XfsmBoundYmax + ( XFSM_UNIT << 1 );

  XfsmRecomputeBound = XFSM_FALSE;

  autend();
  return( XFSM_TRUE );
}
