/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XFSM                            |
|                                                             |
| File    :                  Search.c                         |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <math.h>
# include <Xm/Xm.h>
# include <Xm/PushBG.h>

# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include XSB_H
# include XTB_H
# include XMX_H
# include XFS_H
# include XME_H

# include "XME_search.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char  XfsmSearchAbort;
  int   XfsmSearchNumber;
  char *XfsmSearchString;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    XfsmEditInitializeSearch                 |
|                                                             |
\------------------------------------------------------------*/

void XfsmEditInitializeSearch( Name )

  char *Name;
{
  char *Star;

  autbegin();

  Star = strrchr( Name, '*' );

  if ( Star != (char *)NULL )
  {
    XfsmSearchNumber = (int)(Star - Name);
  }
  else
  {
    XfsmSearchNumber = 0;
  }

  XfsmSearchString = Name;

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                    XfsmEditSearchCompare                    |
|                                                             |
\------------------------------------------------------------*/

int XfsmEditSearchCompare( Name )

  char *Name;
{
  if ( Name != (char *)NULL )
  {
    if ( XfsmSearchNumber )
    {
      return( ! strncmp( XfsmSearchString, Name, XfsmSearchNumber ) );
    }
    else
    {
      return( Name == XfsmSearchString );
    }
  }

  return( 0 );
}

/*------------------------------------------------------------\
|                                                             |
|                       XfsmEditSearchObject                  |
|                                                             |
\------------------------------------------------------------*/

void XfsmEditSearchObject( ObjectName )

  char *ObjectName;
{
  xfsmobj_list    *Obj;
  xfsmselect_list *Search;
  short            Layer;
  long             X1;
  long             Y1;

  autbegin();

  if ( XfsmHeadConnect != (xfsmselect_list *)NULL )
  {
    XfsmDelConnect();
    XfsmZoomRefresh();
  }

  XfsmEditInitializeSearch( ObjectName );

  for ( Layer = 0; Layer < XFSM_MAX_LAYER; Layer++ )
  {
    if ( XFSM_ACTIVE_LAYER_TABLE[ Layer ] == 0 ) continue;

    for ( Obj  = XfsmFigure->TEXT[ Layer ];
          Obj != (xfsmobj_list *)NULL;
          Obj  = Obj->NEXT )
    {
      if ( ! IsXfsmSelect( Obj ) )
      {
        if ( XfsmEditSearchCompare( Obj->NAME ) )
        {
          XfsmAddSelect( Obj );
        }
      }
    }
  }

  for ( Search  = XfsmHeadSelect;
        Search != (xfsmselect_list *)NULL;
        Search  = Search->NEXT )
  {
    XfsmUnselectObject( Search->OBJECT );
  }

  if ( XfsmHeadSelect == (xfsmselect_list *)NULL )
  {
    XfsmWarningMessage( XfsmMainWindow, "No object found !" );
  }
  else
  {
    XfsmSearchAbort = XFSM_FALSE;

    for ( Search  = XfsmHeadSelect;
          Search != (xfsmselect_list *)NULL;
          Search  = Search->NEXT )
    {
      Obj = Search->OBJECT;

      XfsmAddConnect( Obj );

      if ( XfsmSearchAbort ) continue;

      X1 = ( Obj->X + ( Obj->DX >> 1 ) ) / XFSM_UNIT;
      Y1 = ( Obj->Y + ( Obj->DY >> 1 ) ) / XFSM_UNIT;

      XfsmZoomCenter( X1, Y1 );

      if ( Search->NEXT != (xfsmselect_list *)NULL )
      {
        XfsmEnterPanel( &XfsmEditSearchViewPanel );
        XfsmLimitedLoop( XfsmEditSearchViewPanel.PANEL );
      }
    }

    XfsmDelSelect();

    XfsmExitPanel( &XfsmEditSearchViewPanel );
  }

  autend();
}
