/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XFSM                           |
|                                                             |
| File    :                  Motif.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/Form.h>
# include <Xm/Frame.h>
# include <Xm/MainW.h>
 
# include MUT_H
# include AUT_H
# include ABL_H
# include BDD_H
# include FSM_H
# include XSB_H
# include XTB_H
# include XMX_H
# include XMS_H

# include "XMX_motif.h"
# include "XMX_graphic.h" 
# include "XMX_event.h" 
# include "XMX_message.h" 
# include "XMX_menu.h" 
# include "XMX_color.h" 
# include "XMX_panel.h"
# include "XMX_dialog.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  XtAppContext  XfsmApplication;
  Widget        XfsmTopLevel;
  Widget        XfsmMainWindow;
  Widget        XfsmMainForm;
 
  static String XfsmFallBacks [] =

         {
           "*.XfsmMainWindow.iconName : Xfsm",
           "*XfsmMenuBar*fontList     : -*-helvetica-bold-r-*--14-*", 
           "*foreground                : black",
           "*background                : gray",
           "*fontList                  : -*-helvetica-medium-r-*--12-*",
           NULL
         };

  static char XfsmTopLevelTitle[ 128 ] = "Xfsm : ";

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     XfsmChangeTopLevelTitle                 |
|                                                             |
\------------------------------------------------------------*/

void XfsmChangeTopLevelTitle( Title )

  char *Title;
{
  autbegin();

  if ( Title != (char *)NULL )
  {
    strcpy( XfsmTopLevelTitle + 7, Title  );
  }
  else
  {
    XfsmTopLevelTitle[ 7 ] = '\0';
  }

  XtVaSetValues( XfsmTopLevel, XmNtitle, XfsmTopLevelTitle, NULL );

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                    XfsmInitializeRessources                 |
|                                                             |
\------------------------------------------------------------*/

void XfsmInitializeRessources( argc, argv )

     int  *argc;
     char *argv[];
{
  Arg Args[ 2 ];

  autbegin();

  XfsmTopLevel = XtVaAppInitialize(
                                     &XfsmApplication,
                                     "xfsm.xrdb",
                                     NULL,
                                     0,
                                     argc,
                                     argv,
                                     XfsmFallBacks,
                                     NULL 
                                   );

  XfsmLoadTopLevelConfig();

  XfsmMainWindow = XtVaCreateManagedWidget( "XfsmMainWindow",
                                             xmMainWindowWidgetClass,
                                             XfsmTopLevel,
                                             NULL);

  XfsmMainForm = XtVaCreateManagedWidget( "XfsmMainForm",
                                           xmFormWidgetClass,
                                           XfsmMainWindow,
                                           XmNfractionBase,
                                           200,
                                           NULL );

  XfsmInitializeIcon();
  XfsmInitializeMenu();
  XfsmInitializeMessage();
  XfsmInitializePanel(); 
  XfsmInitializeGraphic();
  XfsmInitializeEvent();
  XfsmBuildPanelMap();
  XfsmInitializeMapEvent();
  XfsmInitializeColors();
  XfsmInitializeGraphicContext();
  XfsmInitializeDialog();
  XfsmBuildPanelLibrary();

  XtSetArg( Args[0], XmNallowShellResize, True ); 
  XtSetArg( Args[1], XmNdeleteResponse, XmDO_NOTHING );

  XtSetValues( XfsmTopLevel, Args, 2 );
 
  XtRealizeWidget( XfsmTopLevel );

  autend();
}
