/*------------------------------------------------------------\
|                                                             |
| Tool    :                    XPAT                           |
|                                                             |
| File    :                   File.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <Xm/Xm.h>
# include <Xm/FileSB.h>
# include <Xm/SelectioB.h>
# include <Xm/PushBG.h>

# include MUT_H
# include AUT_H
# include PAT_H
# include XSB_H
# include XPT_H
# include XMX_H
# include XTB_H
# include XMF_H

# include "XMF_file.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char XpatFileFilter[ 10 ]    = "*.";
  char XpatFileExtention[ 10 ] = ".";

  char XpatFileBuffer[ 128 ];
  char XpatDirectoryBuffer[ 512 ];

  char *XPAT_WORK_LIB = (char *)NULL;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         XpatFileOpen                        |
|                                                             |
\------------------------------------------------------------*/

void XpatFileOpen( FileName )

  char *FileName;
{
  int    Index;
  char  *SWAP_WORK_LIB = WORK_LIB;

  autbegin();

  XpatSetMouseCursor( XpatGraphicWindow, XPAT_WATCH_CURSOR  );
  XpatUndisplayCursor();

  XpatDelConnect();
  XpatDelFigure();

  XpatRecomputeBound = XPAT_TRUE;

  if ( XPAT_WORK_LIB == (char *)NULL )
  {
    XPAT_WORK_LIB = WORK_LIB;
  }

  if ( XpatFileFilter[2] == '\0' )
  {
    strcat( XpatFileFilter, "pat"    );
    strcat( XpatFileExtention, "pat" );
  }

  for ( Index = strlen( FileName ); Index >= 0; Index-- )
  {
    if ( FileName[ Index ] == '/' ) break;
  }

  if ( Index >= 0 )
  {
    strcpy( XpatDirectoryBuffer, FileName );
    strcpy( XpatFileBuffer, FileName + Index + 1);

    XpatDirectoryBuffer[ Index + 1 ] = '\0';

    WORK_LIB = XpatDirectoryBuffer;
  }
  else
  {
    strcpy( XpatFileBuffer, FileName );

    WORK_LIB = XPAT_WORK_LIB;
  }

  Index = strlen( XpatFileBuffer ) - strlen( XpatFileExtention );

  if ( Index >= 0 )
  {
    if ( ! strcmp( XpatFileBuffer + Index, XpatFileExtention ) )
    {
      XpatFileBuffer[ Index ] = '\0';
    }
  }

  XpatLoadFigure( XpatFileBuffer );

  if ( XpatFigure != (xpatfig_list *)NULL )
  {
    XpatChangeTopLevelTitle( XpatFileBuffer );
  }
  else
  {
    XpatChangeTopLevelTitle( (char *)NULL );
  }

  XpatDisplayToolsMessage();

  XpatInitializeZoom();
  XpatDisplayFigure( 0, 0, XpatGraphicDx, XpatGraphicDy );

  XpatRefreshGraphicWindow( 0, 0,
                             XpatGraphicDx, XpatGraphicDy );

  XpatSetMouseCursor( XpatGraphicWindow, XPAT_NORMAL_CURSOR );
  XpatDisplayCursor();

  WORK_LIB = SWAP_WORK_LIB;

  autend();
}
