/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XPAT                           |
|                                                             |
| File    :                  Motif.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/Form.h>
# include <Xm/Frame.h>
# include <Xm/MainW.h>
 
# include MUT_H
# include AUT_H
# include PAT_H
# include XSB_H
# include XTB_H
# include XMX_H
# include XMS_H

# include "XMX_motif.h"
# include "XMX_graphic.h" 
# include "XMX_event.h" 
# include "XMX_message.h" 
# include "XMX_menu.h" 
# include "XMX_color.h" 
# include "XMX_panel.h"
# include "XMX_dialog.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  XtAppContext  XpatApplication;
  Widget        XpatTopLevel;
  Widget        XpatMainWindow;
  Widget        XpatMainForm;
 
  static String XpatFallBacks [] =

         {
           "*.XpatMainWindow.iconName : Xpat",
           "*XpatMenuBar*fontList     : -*-helvetica-bold-r-*--14-*", 
           "*foreground                : black",
           "*background                : gray",
           "*fontList                  : -*-helvetica-medium-r-*--12-*",
           NULL
         };

  static char XpatTopLevelTitle[ 128 ] = "Xpat : ";

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     XpatChangeTopLevelTitle                 |
|                                                             |
\------------------------------------------------------------*/

void XpatChangeTopLevelTitle( Title )

  char *Title;
{
  autbegin();

  if ( Title != (char *)NULL )
  {
    strcpy( XpatTopLevelTitle + 7, Title  );
  }
  else
  {
    XpatTopLevelTitle[ 7 ] = '\0';
  }

  XtVaSetValues( XpatTopLevel, XmNtitle, XpatTopLevelTitle, NULL );

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                    XpatInitializeRessources                 |
|                                                             |
\------------------------------------------------------------*/

void XpatInitializeRessources( argc, argv )

     int  *argc;
     char *argv[];
{
  Arg Args[ 2 ];

  autbegin();

  XpatTopLevel = XtVaAppInitialize(
                                     &XpatApplication,
                                     "xpat.xrdb",
                                     NULL,
                                     0,
                                     argc,
                                     argv,
                                     XpatFallBacks,
                                     NULL 
                                   );

  XpatLoadTopLevelConfig();

  XpatMainWindow = XtVaCreateManagedWidget( "XpatMainWindow",
                                             xmMainWindowWidgetClass,
                                             XpatTopLevel,
                                             NULL);

  XpatMainForm = XtVaCreateManagedWidget( "XpatMainForm",
                                           xmFormWidgetClass,
                                           XpatMainWindow,
                                           XmNfractionBase,
                                           200,
                                           NULL );

  XpatInitializeIcon();
  XpatInitializeMenu();
  XpatInitializeMessage();
  XpatInitializePanel(); 
  XpatInitializeGraphic();
  XpatInitializeEvent();
  XpatBuildPanelMap();
  XpatInitializeMapEvent();
  XpatInitializeColors();
  XpatInitializeGraphicContext();
  XpatInitializeDialog();
  XpatBuildPanelLibrary();

  XtSetArg( Args[0], XmNallowShellResize, True ); 
  XtSetArg( Args[1], XmNdeleteResponse, XmDO_NOTHING );

  XtSetValues( XpatTopLevel, Args, 2 );
 
  XtRealizeWidget( XpatTopLevel );

  autend();
}
