/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XPAT                            |
|                                                             |
| File    :                  Bound.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include MUT_H
# include AUT_H
# include PAT_H
# include XSB_H
# include XPT_H
# include "XPT_bound.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  long         XpatBoundXmin   = 0;
  long         XpatBoundYmin   = 0;
  long         XpatBoundXmax   = 0;
  long         XpatBoundYmax   = 0;

  char         XpatRecomputeBound = XPAT_TRUE; 

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     XpatComputeBound                        |
|                                                             |
\------------------------------------------------------------*/

char XpatComputeBound()

{
  xpatobj_list *Obj;
  short         Layer;
  short         FirstBound;

  if ( XpatFigure == (xpatfig_list *)NULL )
  {
    return( XPAT_FALSE );
  }

  if ( XpatRecomputeBound == XPAT_FALSE )
  {
    return( XPAT_TRUE );
  }

  autbegin();

  FirstBound = 1;

  for ( Layer = 0; Layer < XPAT_MAX_LAYER; Layer++ )
  {
    for ( Obj  = XpatFigure->OBJECT[ Layer ];
          Obj != (xpatobj_list *)NULL;
          Obj  = Obj->NEXT )
    {
      if ( FirstBound )
      {
        XpatBoundXmin   = Obj->X;
        XpatBoundYmin   = Obj->Y;
        XpatBoundXmax   = Obj->X + Obj->DX;
        XpatBoundYmax   = Obj->Y + Obj->DY;
        FirstBound      = 0;
      }
      else
      {
        if ( Obj->X < XpatBoundXmin )
        {
          XpatBoundXmin = Obj->X;
        }

        if ( Obj->Y < XpatBoundYmin )
        {
          XpatBoundYmin = Obj->Y;
        }

        if ( ( Obj->X + Obj->DX ) > XpatBoundXmax )
        {
          XpatBoundXmax = Obj->X + Obj->DX;
        }

        if ( ( Obj->Y + Obj->DY ) > XpatBoundYmax )
        {
          XpatBoundYmax = Obj->Y + Obj->DY;
        }
      }
    }
  }

  XpatBoundXmin = XpatBoundXmin - ( XPAT_UNIT << 1 );
  XpatBoundYmin = XpatBoundYmin - ( XPAT_UNIT << 1 );
  XpatBoundXmax = XpatBoundXmax + ( XPAT_UNIT << 1 );
  XpatBoundYmax = XpatBoundYmax + ( XPAT_UNIT << 1 );

  XpatRecomputeBound = XPAT_FALSE;

  autend();
  return( XPAT_TRUE );
}
