/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                            |
|                                                             |
| File    :                   Edit.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

#include <stdio.h>
#include <math.h>
#include <Xm/Xm.h>
#include <Xm/PushBG.h>

#include MUT_H
#include AUT_H
#include MLO_H
#include CNS_H

#include SCL_H
#include XSB_H
#include XTB_H
#include XMX_H
#include XSC_H
#include XME_H
#include XMV_H

#include "XME_edit.h"
#include "XME_select.h"
#include "XME_panel.h"
#include "XME_message.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Identify Buffer                      |
|                                                             |
\------------------------------------------------------------*/

static char     XschIdentifyMessage[XSCH_IDENTIFY_MESSAGE_SIZE];
static char     XschIdentifyBuffer[XSCH_IDENTIFY_BUFFER_SIZE];


static char    *XschScanIdentify;
static long     XschIdentifyLength;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

void
XschIdentifyCone(ptcone0)
    cone_list      *ptcone0;

{
    long            counter;
    locon_list     *ptlocon;
    short           error = 0;
    ptype_list     *ptptype;
    long            counter1;
    chain_list     *ptchain;
    char            cone_type[8];
    char            cone_tectype[16];
    edge_list      *ptedge;
    cone_list      *ptcone1;
    branch_list    *ptbranch;
    char            Buffer[255];

    *XschIdentifyBuffer = '\0';    
    sprintf(Buffer, "\n(CONE");
    strcat(XschIdentifyBuffer, Buffer);
    sprintf(Buffer, "\n\n(%ld %s", ptcone0->INDEX, ptcone0->NAME);
    strcat(XschIdentifyBuffer, Buffer);
    strcpy(cone_type, "");
    if ((ptcone0->TYPE & CNS_MEMSYM) == CNS_MEMSYM)
	strcat(cone_type, "M");
    if ((ptcone0->TYPE & CNS_LATCH) == CNS_LATCH)
	strcat(cone_type, "L");
    if ((ptcone0->TYPE & CNS_RS) == CNS_RS)
	strcat(cone_type, "S");
    if ((ptcone0->TYPE & CNS_FLIP_FLOP) == CNS_FLIP_FLOP)
	strcat(cone_type, "F");
    if ((ptcone0->TYPE & CNS_MASTER) == CNS_MASTER)
	strcat(cone_type, "m");
    if ((ptcone0->TYPE & CNS_SLAVE) == CNS_SLAVE)
	strcat(cone_type, "s");
    if ((ptcone0->TYPE & CNS_TRI) == CNS_TRI)
	strcat(cone_type, "T");
    if ((ptcone0->TYPE & CNS_CONFLICT) == CNS_CONFLICT)
	strcat(cone_type, "C");
    if ((ptcone0->TYPE & CNS_EXT) == CNS_EXT)
	strcat(cone_type, "Ext");
    if ((ptcone0->TYPE & CNS_VDD) == CNS_VDD)
	strcat(cone_type, "Vdd");
    if ((ptcone0->TYPE & CNS_GND) == CNS_GND)
	strcat(cone_type, "Gnd");
    if ((ptcone0->TYPE & CNS_VSS) == CNS_VSS)
	strcat(cone_type, "Vss");

/* if (strlen(cone_type) == 0) 
   {
   strcat(cone_type, "?");
   error = 1;
   } */
    sprintf(Buffer, " %s -", cone_type);
    strcat(XschIdentifyBuffer, Buffer);

    strcpy(cone_tectype, "");
    if ((ptcone0->TECTYPE & CNS_DUAL_CMOS) == CNS_DUAL_CMOS)
	strcat(cone_tectype,
	       "dC");
    else if ((ptcone0->TECTYPE & CNS_CMOS) == CNS_CMOS)
	strcat(cone_tectype, "Cm");
    if ((ptcone0->TECTYPE & CNS_VDD_DEGRADED) == CNS_VDD_DEGRADED)
	strcat(cone_tectype, "VddD");

    if ((ptcone0->TECTYPE & CNS_GND_DEGRADED) == CNS_GND_DEGRADED)
	strcat(cone_tectype, "GndD");
    if ((ptcone0->TECTYPE & CNS_VSS_DEGRADED) == CNS_VSS_DEGRADED)
	strcat(cone_tectype, "VssD");
    if ((ptcone0->TECTYPE & CNS_NOR) == CNS_NOR)
	strcat(cone_tectype, "Nor");
    if ((ptcone0->TECTYPE & CNS_OR) == CNS_OR)
	strcat(cone_tectype, "Or");
    if ((ptcone0->TECTYPE & CNS_PR_NOR) == CNS_PR_NOR)
	strcat(cone_tectype, "Pr_Nor");
    if ((ptcone0->TECTYPE & CNS_SBE) == CNS_SBE)
	strcat(cone_tectype, "Sbe");
    if ((ptcone0->TECTYPE & CNS_SBD) == CNS_SBD)
	strcat(cone_tectype, "Sbd");
    if ((ptcone0->TECTYPE & CNS_TRISTATE_O) == CNS_TRISTATE_O)
	strcat(cone_tectype, "Tristate_o");
    if ((ptcone0->TECTYPE & CNS_SQUIRT_O) == CNS_SQUIRT_O)
	strcat(cone_tectype, "Squirt_o");
    if ((ptcone0->TECTYPE & CNS_LATCH_O) == CNS_LATCH_O)
	strcat(cone_tectype, "Latch_o");
    if ((ptcone0->TECTYPE & CNS_PR_BUS) == CNS_PR_BUS)
	strcat(cone_tectype, "Pr_Bus");
    if ((ptcone0->TECTYPE & CNS_ZERO) == CNS_ZERO)
	strcat(cone_tectype, "Zero");
    if ((ptcone0->TECTYPE & CNS_ONE) == CNS_ONE)
	strcat(cone_tectype, "One");
/* if (strlen(cone_tectype) == 0) 
   {
   ctrcat(cone_tectype, "?");
   error = 1;
   } */
    sprintf(Buffer, " %s", cone_tectype);
    strcat(XschIdentifyBuffer, Buffer);

    sprintf(Buffer, " %ld %ld %ld %ld", ptcone0->XM, ptcone0->Xm, ptcone0->YM, ptcone0->Ym);
    strcat(XschIdentifyBuffer, Buffer);

    /* ------------------------------------------------------------------------
       cone inputs
       ------------------------------------------------------------------------ */
    sprintf(Buffer, "\n(INPUT");
    strcat(XschIdentifyBuffer, Buffer);
    if (ptcone0->INCONE != NULL)
      {
	  for (ptedge = ptcone0->INCONE; ptedge != NULL; ptedge = ptedge->NEXT)
	    {
		if ((ptedge->TYPE & CNS_CONE) == CNS_CONE)
		  {
		      sprintf(Buffer, "\n(Cone");
                      strcat(XschIdentifyBuffer, Buffer);
		      ptcone1 = ptedge->UEDGE.CONE;
		      if (ptcone1 != NULL)
			{
			    if ((ptedge->TYPE & CNS_BLEEDER) == CNS_BLEEDER)
			      {
				  sprintf(Buffer, " bleeder");
                                  strcat(XschIdentifyBuffer, Buffer);
			      }
			    if ((ptedge->TYPE & CNS_COMMAND) == CNS_COMMAND)
			      {
				  sprintf(Buffer, " command");
                                  strcat(XschIdentifyBuffer, Buffer);
			      }
			    if ((ptedge->TYPE & CNS_LOOP) == CNS_LOOP)
			      {
				  sprintf(Buffer, " loop");
                                  strcat(XschIdentifyBuffer, Buffer);
			      }
			    if ((ptedge->TYPE & CNS_FEEDBACK) == CNS_FEEDBACK)
			      {
				  sprintf(Buffer, " feedback");
                                  strcat(XschIdentifyBuffer, Buffer);
			      }
			    sprintf(Buffer, " %ld)", ptcone1->INDEX);
                            strcat(XschIdentifyBuffer, Buffer);
			}
		      else
			{
			    sprintf(Buffer, " ?)");
                            strcat(XschIdentifyBuffer, Buffer);
			    error = 1;
			}
		  }
		else if ((ptedge->TYPE & CNS_VDD) == CNS_VDD)
		  {
		      sprintf(Buffer, "\n(Vdd");
                      strcat(XschIdentifyBuffer, Buffer);
		      ptcone1 = ptedge->UEDGE.CONE;
		      if (ptcone1 != NULL)
			{
			    sprintf(Buffer, " %ld)", ptcone1->INDEX);
                            strcat(XschIdentifyBuffer, Buffer);
			}
		      else
			{
			    sprintf(Buffer, " ?)");
                            strcat(XschIdentifyBuffer, Buffer);
			    error = 1;
			}
		  }
		else if ((ptedge->TYPE & CNS_GND) == CNS_GND)
		  {
		      sprintf(Buffer, "\n(Gnd");
                      strcat(XschIdentifyBuffer, Buffer);
		      ptcone1 = ptedge->UEDGE.CONE;
		      if (ptcone1 != NULL)
			{
			    sprintf(Buffer, " %ld)", ptcone1->INDEX);
                            strcat(XschIdentifyBuffer, Buffer);
			}
		  }
		else
		  {
		      sprintf(Buffer, " ?)");
                      strcat(XschIdentifyBuffer, Buffer);
		      error = 1;
		  }
	    }
       }
	  else
	  if ((ptedge->TYPE & CNS_VSS) == CNS_VSS)
	    {
		sprintf(Buffer, "\n(Vss");
                strcat(XschIdentifyBuffer, Buffer);
		ptcone1 = ptedge->UEDGE.CONE;
		if (ptcone1 != NULL)
		  {
		      sprintf(Buffer, " %ld)", ptcone1->INDEX);
                      strcat(XschIdentifyBuffer, Buffer);
		  }
		else
		  {
		      sprintf(Buffer, " ?)");
                      strcat(XschIdentifyBuffer, Buffer);
		      error = 1;
		  }
	    }
	  else if ((ptedge->TYPE & CNS_EXT) == CNS_EXT)
	    {
		sprintf(Buffer, "\n(Ext");
                strcat(XschIdentifyBuffer, Buffer);
		ptlocon = ptedge->UEDGE.LOCON;
		if ((ptlocon != NULL) && ((ptptype = getptype(ptlocon->USER, (long) CNS_INDEX)) != NULL))
		  {
		      sprintf(Buffer, " %ld)", *((long *) ptptype->DATA));
                      strcat(XschIdentifyBuffer, Buffer);
		  }
		else
		  {
		      sprintf(Buffer, " ?)");
                      strcat(XschIdentifyBuffer, Buffer);
		      error = 1;
		  }
	    }
	  else
	    {
		sprintf(Buffer, "\n(? ?)");
                strcat(XschIdentifyBuffer, Buffer);
		error = 1;
	    }
      

 sprintf(Buffer, ")"); 
 strcat(XschIdentifyBuffer, Buffer);

  /* ------------------------------------------------------------------------
     cone outputs
     ------------------------------------------------------------------------ */
sprintf(Buffer, "\n(OUTPUT");
strcat(XschIdentifyBuffer, Buffer);
if (ptcone0->OUTCONE != NULL)
  {
      for (ptedge = ptcone0->OUTCONE; ptedge != NULL; ptedge = ptedge->NEXT)
	{
	    if ((ptedge->TYPE & CNS_CONE) == CNS_CONE)
	      {
		  sprintf(Buffer, "\n(Cone");
                  strcat(XschIdentifyBuffer, Buffer);
		  ptcone1 = ptedge->UEDGE.CONE;
		  if (ptcone1 != NULL)
		    {
			if ((ptedge->TYPE & CNS_BLEEDER) == CNS_BLEEDER)
			  {
			      sprintf(Buffer, " bleeder");
                              strcat(XschIdentifyBuffer, Buffer);
			  }
			if ((ptedge->TYPE & CNS_COMMAND) == CNS_COMMAND)
			  {
			      sprintf(Buffer, " command");
                              strcat(XschIdentifyBuffer, Buffer);
			  }
			if ((ptedge->TYPE & CNS_LOOP) == CNS_LOOP)
			  {
			      sprintf(Buffer, " loop");
                              strcat(XschIdentifyBuffer, Buffer);
			  }
			if ((ptedge->TYPE & CNS_FEEDBACK) == CNS_FEEDBACK)
			  {
			      sprintf(Buffer, " feedback");
                              strcat(XschIdentifyBuffer, Buffer);
			  }
			sprintf(Buffer, " %ld)", ptcone1->INDEX);
                        strcat(XschIdentifyBuffer, Buffer);
		    }
		  else
		    {
			sprintf(Buffer, " ?)");
                        strcat(XschIdentifyBuffer, Buffer);
			error = 1;
		    }
	      }
	    else if ((ptedge->TYPE & CNS_EXT) == CNS_EXT)
	      {
		  sprintf(Buffer, "\n(Ext");
                  strcat(XschIdentifyBuffer, Buffer);
		  ptlocon = ptedge->UEDGE.LOCON;
		  if ((ptlocon != NULL) && ((ptptype = getptype(ptlocon->USER, (long) CNS_INDEX)) != NULL))
		    {
			sprintf(Buffer, " %ld)", *((long *) ptptype->DATA));
                        strcat(XschIdentifyBuffer, Buffer);
		    }
		  else
		    {
			sprintf(Buffer, " ?)");
                        strcat(XschIdentifyBuffer, Buffer);
			error = 1;
		    }
	      }
	    else
	      {
		  sprintf(Buffer, "\n(? ?)");
                  strcat(XschIdentifyBuffer, Buffer);
		  error = 1;
	      }
	}
      sprintf(Buffer, ")");
      strcat(XschIdentifyBuffer, Buffer);
  }
   /* ------------------------------------------------------------------------
      cone branches
      ------------------------------------------------------------------------ */
sprintf(Buffer, "\n(BRANCHES");
strcat(XschIdentifyBuffer, Buffer);
counter = 0;
for (ptbranch = ptcone0->BRVDD; ptbranch != NULL; ptbranch = ptbranch->NEXT)
  {
      if (treatbr(ptbranch, ++counter))
	{
	    error = 1;
	    counter--;
	}
  }
for (ptbranch = ptcone0->BRGND; ptbranch != NULL; ptbranch = ptbranch->NEXT)
  {
      if (treatbr(ptbranch, ++counter))
	{
	    error = 1;
	    counter--;
	}
  }
for (ptbranch = ptcone0->BRVSS; ptbranch != NULL; ptbranch = ptbranch->NEXT)
  {
      if (treatbr(ptbranch, ++counter))
	{
	    error = 1;
	    counter--;
	}
  }
for (ptbranch = ptcone0->BREXT; ptbranch != NULL; ptbranch = ptbranch->NEXT)
  {
      if (treatbr(ptbranch, ++counter))
	{
	    error = 1;
	    counter--;
	}
  }
sprintf(Buffer, ")");
strcat(XschIdentifyBuffer, Buffer);
   /* ------------------------------------------------------------------------
      cells containg the cone
      ------------------------------------------------------------------------ */
if ((ptchain = ptcone0->CELLS) != NULL)
  {
      sprintf(Buffer, "\n(CELLS");
      strcat(XschIdentifyBuffer, Buffer);
      if ((ptptype = getptype(((cell_list *) ptchain->DATA)->USER, (long) CNS_INDEX)) != NULL)
	{
	    sprintf(Buffer, "\n(%ld", *((long *) ptptype->DATA));
            strcat(XschIdentifyBuffer, Buffer);
	}
      else
	{
	    sprintf(Buffer, "\n(?");
            strcat(XschIdentifyBuffer, Buffer);
	}
      counter1 = 1;
      for (ptchain = ptchain->NEXT; ptchain != NULL; ptchain = ptchain->NEXT)
	{
	    if (counter1++ == 9)
	      {
		  sprintf(Buffer, "\n");
                  strcat(XschIdentifyBuffer, Buffer);
		  counter1 = 1;
	      }
	    if (ptchain->DATA != NULL)
	      {
		  if ((ptptype = getptype(((cell_list *) ptchain->DATA)->USER, (long) CNS_INDEX)) != NULL)
		    {
			sprintf(Buffer, " %ld", *((long *) ptptype->DATA));
                        strcat(XschIdentifyBuffer, Buffer);
		    }
		  else
		    {
			sprintf(Buffer, " ?");
                        strcat(XschIdentifyBuffer, Buffer);
		    }
	      }
	    else
	      {
		  sprintf(Buffer, " ?");
                  strcat(XschIdentifyBuffer, Buffer);
		  error = 1;
	      }
	}
      sprintf(Buffer, "))");
      strcat(XschIdentifyBuffer, Buffer);
  }

}


/*============================================================================*
 | function treatbr();                                                        |
 *============================================================================*/
short           treatbr(ptbranch, counter)

branch_list    *ptbranch;
long            counter;

{
long           *ptlong;
char            branch_type[8];
char            lotrs_type[8];
short           error = 0;
link_list      *ptlink = NULL;
lotrs_list     *ptlotrs = NULL;
ptype_list     *ptptype = NULL;
locon_list     *ptlocon = NULL;
char            Buffer[255];


if (ptbranch->LINK != NULL) {
   strcpy(branch_type, "");
   if ((ptbranch->TYPE & CNS_NOT_FUNCTIONAL) == CNS_NOT_FUNCTIONAL) strcat(branch_type, "Nf");
   if ((ptbranch->TYPE & CNS_BLEEDER) == CNS_BLEEDER) strcat(branch_type, "B");
   if ((ptbranch->TYPE & CNS_DEGRADED) == CNS_DEGRADED) strcat(branch_type, "D");
   if ((ptbranch->TYPE & CNS_FEEDBACK) == CNS_FEEDBACK) strcat(branch_type, "F");
   if ((ptbranch->TYPE & CNS_PARALLEL_INS) == CNS_PARALLEL_INS) strcat(branch_type, "p");
   else if ((ptbranch->TYPE & CNS_PARALLEL) == CNS_PARALLEL) strcat(branch_type, "P");
   if ((ptbranch->TYPE & CNS_VDD) == CNS_VDD) strcat(branch_type, "Vdd");
   if ((ptbranch->TYPE & CNS_GND) == CNS_GND) strcat(branch_type, "Gnd");
   if ((ptbranch->TYPE & CNS_VSS) == CNS_VSS) strcat(branch_type, "Vss");
   if ((ptbranch->TYPE & CNS_EXT) == CNS_EXT) strcat(branch_type, "Ext");
   if (strlen(branch_type) == 0) {
      strcat(branch_type, "?");
      error = 1;
      }
   ptlong = (long *)mbkalloc(sizeof(long)); *ptlong = counter;
   if ((ptptype = getptype(ptbranch->USER, (long)CNS_INDEX)) != NULL) {
      ptptype->DATA = (void *)ptlong;
      }
   else {
      ptbranch->USER = addptype(ptbranch->USER, (long)CNS_INDEX, (void *)ptlong);
      }
   sprintf(Buffer, "\n(%ld %s", counter, branch_type);
   strcat(XschIdentifyBuffer, Buffer);
   for (ptlink = ptbranch->LINK; ptlink != NULL; ptlink = ptlink->NEXT) {
      if ((ptlink->TYPE & CNS_EXT) != CNS_EXT) {
         strcpy(lotrs_type, "");
         if ((ptlink->TYPE & CNS_SW) == CNS_SW) strcat(lotrs_type, "S");
         if ((ptlink->TYPE & CNS_PULL) == CNS_PULL) strcat(lotrs_type, "P");
         if ((ptlink->TYPE & CNS_DRIV_PULL) == CNS_DRIV_PULL) strcat(lotrs_type, "p");
         if ((ptlink->TYPE & CNS_DIODE_UP) == CNS_DIODE_UP) strcat(lotrs_type, "DU");
         if ((ptlink->TYPE & CNS_DIODE_DOWN) == CNS_DIODE_DOWN) strcat(lotrs_type, "DD");
         if ((ptlink->TYPE & CNS_RESIST) == CNS_RESIST) strcat(lotrs_type, "R");
         if ((ptlink->TYPE & CNS_CAPA) == CNS_CAPA) strcat(lotrs_type, "C");
         if ((ptlink->TYPE & CNS_DIPOLE) == CNS_DIPOLE) strcat(lotrs_type, "d");
         if ((ptlink->TYPE & CNS_SWITCH) == CNS_SWITCH) strcat(lotrs_type, "_s");
         if ((ptlink->TYPE & CNS_COMMAND) == CNS_COMMAND) strcat(lotrs_type, "_c");
         if (strlen(lotrs_type) == 0) {
            strcat(lotrs_type, "?");
            error = 1;
            }
         sprintf(Buffer, "\n(%s", lotrs_type);
         strcat(XschIdentifyBuffer, Buffer);
         ptlotrs = ptlink->ULINK.LOTRS;
         if (ptlotrs != NULL) {
            if (strcmp(CNS_TECHNO, "edmesfet") == 0) {
               if (ptlotrs->TYPE == TRANSN) {
                  sprintf(Buffer, " E");
                  strcat(XschIdentifyBuffer, Buffer);
                  }
               else if (ptlotrs->TYPE == TRANSP) {
                  sprintf(Buffer, " D");
                  strcat(XschIdentifyBuffer, Buffer);
                  }
               else {
                  sprintf(Buffer, " ?");
                  strcat(XschIdentifyBuffer, Buffer);
                  error = 1;
                  }
               }
            else if (strcmp(CNS_TECHNO, "npmosfet") == 0) 
                 {
                   if (ptlotrs->TYPE == TRANSN) 
                   {
                     sprintf(Buffer, " N");
                     strcat(XschIdentifyBuffer, Buffer);
                   }
               else if (ptlotrs->TYPE == TRANSP) 
                    {
                       sprintf(Buffer, " P");
                      strcat(XschIdentifyBuffer, Buffer);
                    }
               else {
                  sprintf(Buffer, " ?");
                  strcat(XschIdentifyBuffer, Buffer);
                  error = 1;
                  }
               }
            else {
               sprintf(Buffer, " ?");
               strcat(XschIdentifyBuffer, Buffer);
               error = 1;
               }
            if ((ptptype = getptype(ptlotrs->USER, (long)CNS_INDEX)) != NULL) {
               sprintf(Buffer, " %ld", *((long *)ptptype->DATA));
               strcat(XschIdentifyBuffer, Buffer);
               }
            else {
               sprintf(Buffer, " ?");
               strcat(XschIdentifyBuffer, Buffer);
               error = 1;
               }
            }
         }
      else {
         if ((ptlink->TYPE & CNS_IN) == CNS_IN) {
            sprintf(Buffer, "\n(In");
            strcat(XschIdentifyBuffer, Buffer);
            }
         else if ((ptlink->TYPE & CNS_INOUT) == CNS_INOUT) {
            sprintf(Buffer, "\n(InOut");
            strcat(XschIdentifyBuffer, Buffer);
            }
         else {
            sprintf(Buffer, "\n(?");
            strcat(XschIdentifyBuffer, Buffer);
            error = 1;
            }
         ptlocon = ptlink->ULINK.LOCON;
         if ((ptlocon != NULL) && ((ptptype = getptype(ptlocon->USER, (long)CNS_INDEX)) != NULL)) {
            sprintf(Buffer, " %ld", *((long *)ptptype->DATA));
            strcat(XschIdentifyBuffer, Buffer);
            }
         else {
            sprintf(Buffer, " ?");
            strcat(XschIdentifyBuffer, Buffer);
            error = 1;
            }
         }
      sprintf(Buffer, " %3.2f", ptlink->CAPA);
      strcat(XschIdentifyBuffer, Buffer);
      sprintf(Buffer, ")");
      strcat(XschIdentifyBuffer, Buffer);
      }
   sprintf(Buffer, ")");
   strcat(XschIdentifyBuffer, Buffer);
   }

return(error);
}




 /*------------------------------------------------------------\
 |                                                             |
 |                         XschAddIdentify                     |
 |                                                             |
 \------------------------------------------------------------*/

void
XschNetIdentify(SchNet)
    schnet_list    *SchNet;
{
    char           *Scan;
    chain_list     *ScanChain;
    schcon_list    *SchCon;

    autbegin();


    /* *****************  Identify des NET ******************** */

    Scan = XschIdentifyBuffer;
    strcpy(Scan, "SIGNAL : \n\n");
    Scan += strlen(Scan);

    for (ScanChain = SchNet->CON_NET;
	 ScanChain != (chain_list *) 0;
	 ScanChain = ScanChain->NEXT)
      {
	  SchCon = (schcon_list *) ScanChain->DATA;
          if (SchCon->ROOT_TYPE == SCH_ROOT_CON_BOX)
          {
             if (!IsSchBoxTransparence( (schbox_list *)SchCon->ROOT ) )
             {
	       sprintf(Scan, "> CONNECTOR : %s of INSTANCE %s\n", SchCon->NAME
                        ,((schbox_list *) (SchCon->ROOT))->NAME);
	       Scan += strlen(Scan);
             }
          }
      }

    autend();
}

/*------------------------------------------------------------\
|                                                             |
|                         XschAddIdentify                     |
|                                                             |
\------------------------------------------------------------*/


short XschAddIdentify(Obj)

    xschobj_list   *Obj;
{
    long            Length;
    schbox_list    *SchBox;
    schnet_list    *SchNet;
    schcon_list    *SchCon;
    char            StrCon[XSCH_IDENTIFY_BUFFER_SIZE];

    autbegin();

    StrCon[0] = '\0';
    XschIdentifyBuffer[0] = '\0';



       /* ************** Identify des BOX *********** */



    if (IsXschSchBox(Obj))
      {
	  SchBox = (schbox_list *) Obj->USER;

          if (SchBox->SOURCE_TYPE == SCH_SOURCE_LOINS)
          {
	    sprintf(XschIdentifyBuffer,
                    "INSTANCE : %s\nMODEL    : %s\n\n",
                    ((loins_list *) (SchBox->SOURCE))->INSNAME,
                    ((loins_list *) (SchBox->SOURCE))->FIGNAME);
          }  
          else if (SchBox->SOURCE_TYPE == SCH_SOURCE_CNSCONE)
          {
             XschIdentifyCone((cone_list *)SchBox->SOURCE);
          }
      }
    else



	/* ******** Identify des CON ************** */



    if (IsXschSchCon(Obj))
      {
	  SchCon = (schcon_list *) Obj->USER;

          if (SchCon->SOURCE_TYPE == SCH_SOURCE_LOCON)
           {
	     sprintf(XschIdentifyBuffer,
                     "CONNECTOR : %s\n\n", ((locon_list *) (SchCon->SOURCE))->NAME );
           }
      }
    else



	/* ******************* Identify des NET*********** */



    if (IsXschSchNet(Obj))
      {
	  SchNet = (schnet_list *) Obj->USER;

	  if (SchNet->SOURCE != NULL)
	    {

		if (SchNet->SOURCE_TYPE == SCH_SOURCE_LOSIG)
		  {
		      if (SchNet->CON_NET != NULL)
			{
			    XschNetIdentify(SchNet);
			}
		  }
		else if (SchNet->SOURCE_TYPE == SCH_SOURCE_CNSCONE)
		  {
		      XschIdentifyCone((cone_list *)SchNet->SOURCE);
		  }
	    }
      }



    Length = strlen(XschIdentifyBuffer);

    if ((XschIdentifyLength + Length) < (XSCH_IDENTIFY_MESSAGE_SIZE - 1))
      {
	  strcpy(XschScanIdentify, XschIdentifyBuffer);

	  XschScanIdentify += Length;
	  XschIdentifyLength += Length;


	  autend();
	  return (XSCH_TRUE);
      }

    autend();
    return (XSCH_FALSE);
}

/*------------------------------------------------------------\
|                                                             |
|                         XschEditIdentify                    |
|                                                             |
\------------------------------------------------------------*/

void 
XschEditIdentify(X1, Y1)

    long            X1;
    long            Y1;
{
    xschselect_list *Select;

    strcpy(XschIdentifyMessage, "No element found !");

    XschScanIdentify = XschIdentifyMessage;
    XschIdentifyLength = 0;

    XschEditSelectPoint(X1, Y1);

    for (Select = XschHeadSelect;
	 Select != (xschselect_list *) NULL;
	 Select = Select->NEXT)
      {
	  if (!XschAddIdentify(Select->OBJECT))
	      break;
      }

    XschDelSelect();

    XschDisplayEditIdentify(XschIdentifyMessage);
    XschEnterPanel(&XschEditIdentifyPanel);
}

/*------------------------------------------------------------\
|                                                             |
|                         XschEditConnected                   |
|                                                             |
\------------------------------------------------------------*/

void 
XschEditConnected(X1, Y1)

    long            X1;
    long            Y1;
{
    xschselect_list *Select;
    xschobj_list   *Obj;

    if (XschHeadConnect != (xschselect_list *) NULL)
      {
	  XschDelConnect();
	  XschZoomRefresh();
      }

    XschEditSelectPoint(X1, Y1);

    XschDisplaySelectList((char *) NULL);

    for (Select = XschHeadSelect;
	 Select != (xschselect_list *) NULL;
	 Select = Select->NEXT)
      {
	  XschAddSelectList(Select->OBJECT);
      }

    if (XschHeadSelect == (xschselect_list *) NULL)
      {
	  XschWarningMessage(XschMainWindow, "No element found !");
      }
    else
      {
	  if (XschHeadSelect->NEXT != (xschselect_list *) NULL)
	    {
		XschEnterPanel(&XschEditSelectPanel);
		XschLimitedLoop(XschEditSelectPanel.PANEL);
	    }
	  else
	    {
		XschAcceptObject(XschHeadSelect->OBJECT);
		XschDisplayObject(XschHeadSelect->OBJECT);
	    }
      }

    XschPurgeSelect();

    for (Select = XschHeadSelect;
	 Select != (xschselect_list *) NULL;
	 Select = Select->NEXT)
      {
	  XschAddConnect(Select->OBJECT);
      }

    if (XschHeadSelect != (xschselect_list *) NULL)
      {
	  if (XschHeadSelect->NEXT == (xschselect_list *) NULL)
	    {
		Obj = XschHeadSelect->OBJECT;
		XschDelSelect();
		XschDisplayObject(Obj);
	    }
	  else
	    {
		XschDelSelect();
		XschZoomRefresh();
	    }
      }
}
