/*------------------------------------------------------------\
|                                                             |
| Tool    :                    XSCH                           |
|                                                             |
| File    :                   Edit.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <math.h>
# include <string.h>
# include <Xm/Xm.h>
# include <Xm/PushBG.h>
# include <Xm/CascadeBG.h>

# include MUT_H
# include AUT_H
# include MLO_H
# include SCL_H
# include XSB_H
# include XTB_H
# include XMX_H
# include XSC_H
# include XME_H
# include XMV_H

# include "XME_select.h"
# include "XME_panel.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Select Buffer                       |
|                                                             |
\------------------------------------------------------------*/

  static char XschSelectBuffer [ XSCH_SELECT_BUFFER_SIZE  ];

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         XschAddSelectList                   |
|                                                             |
\------------------------------------------------------------*/

void XschAddSelectList( Obj )

  xschobj_list *Obj;
{
  autbegin();

  XschSelectBuffer[0] = '\0';
/*
** To be done
*/
  XschDisplaySelectList( XschSelectBuffer );

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                  XschEditSelectObject                       |
|                                                             |
\------------------------------------------------------------*/

void XschEditSelectObject( Number )

  int Number;
{
  xschselect_list *Select;
  int              Counter;

  autbegin();

  Select = XschHeadSelect;

  for ( Counter = 0; Counter < Number; Counter++ )
  {
    Select = Select->NEXT;
  }

  if ( IsXschAccept( Select->OBJECT ) )
  {
    XschRejectObject( Select->OBJECT );
  }
  else
  {
    XschAcceptObject( Select->OBJECT );
  }

  XschDisplayObject( Select->OBJECT );

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                  XschEditSelectAccept                       |
|                                                             |
\------------------------------------------------------------*/

void XschEditSelectAccept()
{
  autbegin();

  XschPurgeSelect();

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                  XschEditSelectCancel                       |
|                                                             |
\------------------------------------------------------------*/

void XschEditSelectCancel()
{
  autbegin();

  XschEditUnselectAll();

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                       Select Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      XschEditUnselectAll                    |
|                                                             |
\------------------------------------------------------------*/

void XschEditUnselectAll()
{
  xschobj_list *Obj;

  autbegin();

  if ( XschHeadSelect != (xschselect_list *)NULL )
  {
    if ( XschHeadSelect->NEXT == (xschselect_list *)NULL )
    {
      Obj = XschHeadSelect->OBJECT;
      XschDelSelect();
      XschDisplayObject( Obj );
    }
    else
    {
      XschDelSelect();
      XschZoomRefresh();
    }
  }

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                      XschEditObjectNearPoint                |
|                                                             |
\------------------------------------------------------------*/

char XschEditObjectNearPoint( Obj, X1, Y1 )

  xschobj_list *Obj;
  long          X1;
  long          Y1;
{
  short  Type;
  long   X1r;
  long   Y1r;
  long   X2r;
  long   Y2r;
  float  VectorX;
  float  VectorY;
  float  LineX;
  float  LineY;
  float  Norm;
  float  Distance;

  Type = GetXschObjectType( Obj );

  if ( ( Obj->X           <= X1 ) &&
       ( Obj->Y           <= Y1 ) &&
       ( Obj->X + Obj->DX >= X1 ) &&
       ( Obj->Y + Obj->DY >= Y1 ) )
  {
    if ( ( Type == XSCH_OBJECT_LINE  ) ||
         ( Type == XSCH_OBJECT_ARROW ) )
    {
      if ( ( Obj->DX == 0 ) && 
           ( Obj->DY == 0 ) )
      {
        if ( ( Obj->X == X1 ) &&
             ( Obj->Y == Y1 ) )
        {
          return( XSCH_TRUE );
        }
      }
      else
      {
        if ( IsXschLineLeft( Obj ) )
        {
          X1r = Obj->X + Obj->DX;
          X2r = Obj->X;
        }
        else
        {
          X1r = Obj->X;
          X2r = Obj->X + Obj->DX;
        }
    
        if ( IsXschLineDown( Obj ) )
        {
          Y1r  = Obj->Y + Obj->DY;
          Y2r  = Obj->Y;
        }
        else
        {
          Y1r  = Obj->Y;
          Y2r  = Obj->Y + Obj->DY;
        }
  
        LineX   = (float)( X2r - X1r );
        LineY   = (float)( Y2r - Y1r );
        Norm    = sqrt( ( LineX * LineX ) + ( LineY * LineY ) );
        LineX  /= Norm;
        LineY  /= Norm;
  
        VectorX  = (float)( X2r - X1  );
        VectorY  = (float)( Y2r - Y1  );
  
        Distance = fabs( ( VectorX * LineY ) - ( VectorY * LineX ) );

        if ( Distance < (float) XSCH_UNIT )
        {
          return( XSCH_TRUE );
        }
      }
    }
    else
    {
      return( XSCH_TRUE );
    }
  }

  return( XSCH_FALSE );
}

/*------------------------------------------------------------\
|                                                             |
|                       XschEditSelectPoint                   |
|                                                             |
\------------------------------------------------------------*/

void XschEditSelectPoint( X1, Y1 )

  long X1;
  long Y1;
{
  xschobj_list    *Obj;
  xschselect_list *Select;
  int              Layer;

  X1 = X1 * XSCH_UNIT;
  Y1 = Y1 * XSCH_UNIT;

  for ( Layer = 0; Layer < XSCH_MAX_LAYER; Layer++ )
  {
    if ( XSCH_ACTIVE_LAYER_TABLE[ Layer ] == 0 ) continue;

    for ( Obj  = XschFigure->OBJECT[ Layer ];
          Obj != (xschobj_list *)NULL;
          Obj  = Obj->NEXT )
    {
      if ( XSCH_ACTIVE_LAYER_TABLE[ Obj->LAYER ] == 0 ) continue;

      if ( ! IsXschSelect( Obj ) )
      {
        if ( XschEditObjectNearPoint( Obj, X1, Y1 ) )
        {
          XschAddSelect( Obj );
        }
      }
    }
  }

  for ( Select  = XschHeadSelect;
        Select != (xschselect_list *)NULL;
        Select  = Select->NEXT )
  {
    XschUnselectObject( Select->OBJECT );
  }
}
