/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                           |
|                                                             |
| File    :                   View.h                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef XSCH_VIEW
# define XSCH_VIEW

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define XSCH_PERCENT_ZOOM      30
# define XSCH_PERCENT_ZOOM_MIN   5
# define XSCH_PERCENT_ZOOM_MAX  95

# define XSCH_PERCENT_MOVE      30
# define XSCH_PERCENT_MOVE_MIN   5
# define XSCH_PERCENT_MOVE_MAX  95

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/

  typedef struct xschzoom
   {
     struct xschzoom *NEXT;

     long              X;
     long              Y;
     long             DX;
     long             DY;

   } xschzoom;

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  extern int            XschPercentZoom;
  extern int            XschPercentMove;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void XschZoomUndo();
  extern void XschZoomRefresh();

  extern void XschZoomLeft();
  extern void XschZoomRight();
  extern void XschZoomUp();
  extern void XschZoomDown();

  extern void XschZoomMore();
  extern void XschZoomLess();

  extern void XschZoomFit();

  extern void XschInitializeZoom();
  extern void XschInitializeUnitGrid();

# endif 
