/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                           |
|                                                             |
| File    :                  Motif.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
# include <Xm/Form.h>
# include <Xm/Frame.h>
# include <Xm/MainW.h>
 
# include MUT_H
# include AUT_H
# include MLO_H
# include XSB_H
# include XTB_H
# include XMX_H
# include XMS_H

# include "XMX_motif.h"
# include "XMX_graphic.h" 
# include "XMX_event.h" 
# include "XMX_message.h" 
# include "XMX_menu.h" 
# include "XMX_color.h" 
# include "XMX_panel.h"
# include "XMX_icon.h"
# include "XMX_dialog.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  XtAppContext  XschApplication;
  Widget        XschTopLevel;
  Widget        XschMainWindow;
  Widget        XschMainForm;
 
  static String XschFallBacks [] =

         {
           "*.XschMainWindow.iconName : Xsch",
           "*XschMenuBar*fontList     : -*-helvetica-bold-r-*--14-*", 
           "*foreground                : black",
           "*background                : gray",
           "*fontList                  : -*-helvetica-medium-r-*--12-*",
           NULL
         };

  static char XschTopLevelTitle[ 128 ] = "Xsch : ";

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     XschChangeTopLevelTitle                 |
|                                                             |
\------------------------------------------------------------*/

void XschChangeTopLevelTitle( Title )

  char *Title;
{
  autbegin();

  if ( Title != (char *)NULL )
  {
    strcpy( XschTopLevelTitle + 7, Title  );
  }
  else
  {
    XschTopLevelTitle[ 7 ] = '\0';
  }

  XtVaSetValues( XschTopLevel, XmNtitle, XschTopLevelTitle, NULL );

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                    XschInitializeRessources                 |
|                                                             |
\------------------------------------------------------------*/

void XschInitializeRessources( argc, argv )

     int  *argc;
     char *argv[];
{
  Arg Args[ 2 ];

  autbegin();

  XschTopLevel = XtVaAppInitialize(
                                     &XschApplication,
                                     "xsch.xrdb",
                                     NULL,
                                     0,
                                     argc,
                                     argv,
                                     XschFallBacks,
                                     NULL 
                                   );

  XschLoadTopLevelConfig();

  XschMainWindow = XtVaCreateManagedWidget( "XschMainWindow",
                                             xmMainWindowWidgetClass,
                                             XschTopLevel,
                                             NULL);

  XschMainForm = XtVaCreateManagedWidget( "XschMainForm",
                                           xmFormWidgetClass,
                                           XschMainWindow,
                                           XmNfractionBase,
                                           200,
                                           NULL );

  XschInitializeIcon();
  XschInitializeMenu();
  XschInitializeMessage();
  XschInitializePanel(); 
  XschInitializeGraphic();
  XschInitializeEvent();
  XschBuildPanelMap();
  XschInitializeMapEvent();
  XschInitializeColors();
  XschInitializeGraphicContext();
  XschInitializeDialog();
  XschBuildPanelLibrary();

  XtSetArg( Args[0], XmNallowShellResize, True ); 
  XtSetArg( Args[1], XmNdeleteResponse, XmDO_NOTHING );
  XtSetValues( XschTopLevel, Args, 2 );
 
  XtRealizeWidget( XschTopLevel );

  autend();
}
