/*------------------------------------------------------------\
|                                                             |
| Tool    :                    XSCH                           |
|                                                             |
| File    :                  Share.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <Xm/Xm.h>

# include MUT_H
# include AUT_H
# include MLO_H
# include XSB_H
# include "XSB_share.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char XSCH_ACTIVE_NAME_TABLE [ XSCH_MAX_ACTIVE_NAME ] = 
  {
    1, /* PLACE TEXT  */
    1  /* PLACE TRANS */
  };

  char XSCH_ACTIVE_LAYER_TABLE [ XSCH_MAX_LAYER ] = 
  {
    1, 1, 1, 1, 1
  };

  char *XschFirstFileName  = (char *)NULL;
  char *XSCH_XMS_FILE_NAME = (char *)NULL;
  char *XSCH_IN_SCHEM = (char *)NULL;
  int   XschCnsMode        = 0;
  
  char XSCH_FORCE_DISPLAY = XSCH_FALSE;
  char XSCH_XOR_CURSOR    = XSCH_FALSE;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      XschPostTreatString                    |
|                                                             |
\------------------------------------------------------------*/

char *XschPostTreatString( Text )

  char *Text;
{
  char OnlySpace;
  int  Counter;

  autbegin();

  if ( Text != (char *)NULL )
  {
    OnlySpace = 1;

    for ( Counter = 0; Text[ Counter ]; Counter++ )
    {
      if ( Text[ Counter ] != ' ' ) OnlySpace = 0;
    }

    if ( OnlySpace ) Text = (char *)NULL;
  }

  autend();
  return( Text );
}

/*------------------------------------------------------------\
|                                                             |
|                        Xschgetenv                           |
|                                                             |
\------------------------------------------------------------*/

void Xschgetenv()
{
  char *Env;

  Env = getenv( "HOME" );

  if ( Env == (char *)NULL )
  {
    XSCH_XMS_FILE_NAME = XMS_FILE_NAME;
  }
  else
  {
    XSCH_XMS_FILE_NAME =

     (char *)autallocblock( strlen( Env ) + strlen( XMS_FILE_NAME ) + 2 );

    strcpy( XSCH_XMS_FILE_NAME, Env );
    strcat( XSCH_XMS_FILE_NAME, "/" );
    strcat( XSCH_XMS_FILE_NAME, XMS_FILE_NAME );
  }

  Env = getenv("XSCH_IN_SCHEM");
  if ( Env == (char *)NULL )
  {
    XSCH_IN_SCHEM = IN_LO;
  }
  else
  {
    XSCH_IN_SCHEM = (char *)autallocblock( strlen( Env ) + 1);
    strcpy( XSCH_IN_SCHEM,  Env);
    if (Env != NULL) {
      if (!strcmp(Env, "hns"))
         (void)strcpy(XSCH_IN_SCHEM, "hns");
      else if (!strcmp(Env, "fne"))
         (void)strcpy(XSCH_IN_SCHEM, "fne");
      else if (!strcmp(Env, "hdn"))
         (void)strcpy(XSCH_IN_SCHEM, "hdn");
      else if (!strcmp(Env, "fdn"))
         (void)strcpy(XSCH_IN_SCHEM, "fdn");
      else if (!strcmp(Env, "al" ))
         (void)strcpy(XSCH_IN_SCHEM, "al");
      else if (!strcmp(Env, "alx"))
         (void)strcpy(XSCH_IN_SCHEM, "alx");
      else if (!strcmp(Env, "spi"))
         (void)strcpy(XSCH_IN_SCHEM, "spi");
      else if (!strcmp(Env, "sp"))
         (void)strcpy(XSCH_IN_SCHEM, "sp");
      else if (!strcmp(Env, "edi"))
         (void)strcpy(XSCH_IN_SCHEM, "edi");
      else if (!strcmp(Env, "vst"))
         (void)strcpy(XSCH_IN_SCHEM, "vst");
      else if (!strcmp(Env, "cns")) {
         (void)strcpy(XSCH_IN_SCHEM, "cns");
         XschCnsMode = 1;
      }
      else {
         (void)fflush(stdout);
         (void)fprintf(stderr,"*** xsch error ***\n");
         (void)fprintf(stderr,"schematic input format '%s' not supported\n",Env);
         EXIT(1);
      }
    }
  }
}
