/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                            |
|                                                             |
| File    :                  Bound.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include MUT_H
# include AUT_H
# include MLO_H
# include XSB_H
# include XSC_H
# include "XSC_bound.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  long         XschBoundXmin   = 0;
  long         XschBoundYmin   = 0;
  long         XschBoundXmax   = 0;
  long         XschBoundYmax   = 0;

  char         XschRecomputeBound = XSCH_TRUE; 

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     XschComputeBound                       |
|                                                             |
\------------------------------------------------------------*/

char XschComputeBound()

{
  xschobj_list *Obj;
  short         Layer;
  short         FirstBound;

  if ( XschFigure == (xschfig_list *)NULL )
  {
    return( XSCH_FALSE );
  }

  if ( XschRecomputeBound == XSCH_FALSE )
  {
    return( XSCH_TRUE );
  }

  autbegin();

  FirstBound = 1;

  for ( Layer = 0; Layer < XSCH_MAX_LAYER; Layer++ )
  {
    for ( Obj  = XschFigure->OBJECT[ Layer ];
          Obj != (xschobj_list *)NULL;
          Obj  = Obj->NEXT )
    {
      if ( FirstBound )
      {
        XschBoundXmin   = Obj->X;
        XschBoundYmin   = Obj->Y;
        XschBoundXmax   = Obj->X + Obj->DX;
        XschBoundYmax   = Obj->Y + Obj->DY;
        FirstBound      = 0;
      }
      else
      {
        if ( Obj->X < XschBoundXmin )
        {
          XschBoundXmin = Obj->X;
        }

        if ( Obj->Y < XschBoundYmin )
        {
          XschBoundYmin = Obj->Y;
        }

        if ( ( Obj->X + Obj->DX ) > XschBoundXmax )
        {
          XschBoundXmax = Obj->X + Obj->DX;
        }

        if ( ( Obj->Y + Obj->DY ) > XschBoundYmax )
        {
          XschBoundYmax = Obj->Y + Obj->DY;
        }
      }
    }
  }

  XschBoundXmin = XschBoundXmin - ( XSCH_UNIT << 1 );
  XschBoundYmin = XschBoundYmin - ( XSCH_UNIT << 1 );
  XschBoundXmax = XschBoundXmax + ( XSCH_UNIT << 1 );
  XschBoundYmax = XschBoundYmax + ( XSCH_UNIT << 1 );

  XschRecomputeBound = XSCH_FALSE;

  autend();
  return( XSCH_TRUE );
}
