/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                            |
|                                                             |
| File    :                  Trace.c                          |
|                                                             |
| Authors :             Miramond   Benoit                     |
|                       Picault  Stephane		      |
|                                                             |
| Date    :                   10.03.98                       |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <math.h>
# include <signal.h>
# include <string.h>
# include <setjmp.h>
# include MUT_H
# include AUT_H
# include MLO_H
# include XSB_H
# include SCL_H 
# include XSC_H
# include "XSC_place.h"
# include "XSC_schem.h"

# define IsSchWireHorizontal( Z )    (  ( Z )->DY == ( Z )->Y )
# define IsSchWireVertical( Z )      (  ( Z )->DX == ( Z )->X )

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Functions                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Trace Con                         |
|                                                             |
\------------------------------------------------------------*/

void trace_con (con_list, X, Y,LayerCon) 

   schcon_list   *con_list;
   long           X,Y;
   unsigned char  LayerCon;
{
  schcon_list *SchCon;
  xschobj_list  *Object1;
  xschobj_list  *Object2;
  long           X_trace,X_con;
  long           Y_trace,Y_con;
  int            ObjectType;
  long           DeltaX;
  


      for ( SchCon  = con_list ;
	    SchCon != (schcon_list *)0;
	    SchCon  = SchCon->NEXT )
	{


          X_con   =  ( SchCon->X_REL * XSCH_UNIT ); 
          Y_con   =  ( SchCon->Y_REL * XSCH_UNIT )-XSCH_UNIT; 

          if ( IsSchConOut(SchCon) ) 
           {
            X_con -= ( XSCH_UNIT * 2 );
           };

          if ( IsSchConExternal(SchCon))
          {
            if ( IsSchConIn(SchCon)) ObjectType = XSCH_OBJECT_TEXT_LEFT;
            else                     ObjectType = XSCH_OBJECT_TEXT_RIGHT;
          }
          else
          {
            if ( IsSchConIn(SchCon)) ObjectType = XSCH_OBJECT_TEXT_RIGHT;
            else                     ObjectType = XSCH_OBJECT_TEXT_LEFT;
          }

          if ( ObjectType == XSCH_OBJECT_TEXT_LEFT ) DeltaX = - XSCH_UNIT;
          else                                       DeltaX =  3 * XSCH_UNIT;


	  X_trace =  X_con + X;
	  Y_trace =  Y_con + Y; 

          /*
	  Object1 = XschAddHexagon( X_trace, Y_trace, 
				  XSCH_UNIT * 2, XSCH_UNIT * 2, LayerCon );
          */
	  Object1 = XschAddCircle( X_trace + XSCH_UNIT, Y_trace + XSCH_UNIT,
                                   XSCH_UNIT, LayerCon );
	  Object2 = XschAddText( X_trace + DeltaX, Y_trace + XSCH_UNIT,
			         ObjectType, SchCon->NAME, LayerCon );
          Object1->LINK = Object2;
          Object2->LINK = Object1;
	  
	  Object1->USER = (void *)SchCon;
	  Object2->USER = (void *)SchCon;
	  
	  SetXschSchCon( Object1 );
	  SetXschSchCon( Object2 );
  	}
}


/*------------------------------------------------------------\
|                                                             |
|                          XschTrace                          |
|                                                             |
\------------------------------------------------------------*/

void XschTraceFigure ( SchFig )

 schfig_list *SchFig; 
{
  schbox_list   *SchBox;
  schnet_list   *SchNet;
  schwir_list   *SchWir;
  schwir_list   *ScanWir;
  xschobj_list  *Object, *FirstObj, *PrevObj;
  long           X_trace,X_fig,X_box,X_wir,Dx,DX_wir;
  long           MaxY_wire,MinY_wire,Y_trace,Y_fig,Y_box,Y_wir,Dy,DY_wir;
  int            cptmax_wire=0;
  int            cptmin_wire=0;
  unsigned char  Layer;

  /* fig */ 
  

      /*  con  */
     

      X_fig=0;
      Y_fig=0;

      trace_con( SchFig->CON_IN,X_fig,Y_fig,XSCH_SCHCONIN_LAYER);
      trace_con(SchFig->CON_OUT,X_fig,Y_fig,XSCH_SCHCONOUT_LAYER);
      

      /* Nets */ 

      for ( SchNet  = SchFig->NET;
	    SchNet != (schnet_list *)0;
	    SchNet  = SchNet->NEXT )
	{
          FirstObj = NULL;
          PrevObj = NULL;
	  for ( SchWir  = SchNet->WIRE;
	        SchWir != (schwir_list *)0;
	        SchWir  = SchWir->NEXT )
	    {
              X_wir   = SchWir->X * XSCH_UNIT;
              Y_wir   = SchWir->Y * XSCH_UNIT;
              DX_wir   = SchWir->DX * XSCH_UNIT;
              DY_wir   = SchWir->DY * XSCH_UNIT;
  
	      X_trace = X_fig + X_wir;
              Y_trace = Y_fig + Y_wir;

	      Object = XschAddLine( X_trace, Y_trace, DX_wir+X_fig, DY_wir+Y_fig ,XSCH_SCHNET_LAYER ,XSCH_SCHNET_LAYER );
              if (FirstObj == NULL) FirstObj = Object;
              Object->USER = (void *)SchNet;
              SetXschSchNet( Object );
              Object->LINK = Object;            
              if (PrevObj != NULL) PrevObj->LINK = Object;
              PrevObj = Object;
 
              if ( IsSchWireVertical(SchWir) )
              { 
                  cptmax_wire=0;
                  cptmin_wire=0;
 
                if (SchWir->Y < SchWir->DY) 
                { 
                  MaxY_wire = SchWir->DY;
                  MinY_wire = SchWir->Y;
                } 
                else
                { 
                  MaxY_wire = SchWir->Y;
                  MinY_wire = SchWir->DY;
                }
                for ( ScanWir  = SchNet->WIRE;
                      ScanWir != (schwir_list *)0;
                      ScanWir  = ScanWir->NEXT)
                {
                  if ( IsSchWireHorizontal(ScanWir) )
                  {
                    if ( (ScanWir->DX == SchWir->X) || (ScanWir->X == SchWir->X) )
                    {
                      if (    (MinY_wire < ScanWir->Y)
                           && (ScanWir->Y < MaxY_wire) )
                      {
                        Object = XschAddCircle(X_trace , Y_fig + (ScanWir->DY * XSCH_UNIT)
                                       , XSCH_UNIT/2, XSCH_SCHNET_LAYER);
                        Object->USER = (void *)SchNet;
                        SetXschSchNet( Object );
                        PrevObj->LINK = Object;            
                        PrevObj = Object;
                      }
                      if (MaxY_wire != MinY_wire)
                      {
                        if (MaxY_wire == ScanWir->Y) cptmax_wire++;
                        if (MinY_wire == ScanWir->Y) cptmin_wire++;
                      }
                    }
                  }
                }
                if (cptmax_wire >= 2)
                {
                  Object = XschAddCircle(X_trace ,Y_fig + MaxY_wire * XSCH_UNIT
                                  , XSCH_UNIT/2, XSCH_SCHNET_LAYER);
                  Object->USER = (void *)SchNet;
                  SetXschSchNet( Object );
                  PrevObj->LINK = Object;            
                  PrevObj = Object;
                }
                if (cptmin_wire >= 2)
                {
                  Object = XschAddCircle(X_trace ,Y_fig + MinY_wire * XSCH_UNIT
                                  , XSCH_UNIT/2, XSCH_SCHNET_LAYER);
                  Object->USER = (void *)SchNet;
                  SetXschSchNet( Object );
                  PrevObj->LINK = Object;
                  PrevObj = Object;
                }
              } 
	    }
            if (PrevObj != NULL) PrevObj->LINK = FirstObj;
	}
    

      /* box   */
    
      for ( SchBox  = SchFig->BOX;
	    SchBox != (schbox_list *)0;
	    SchBox  = SchBox->NEXT )
	{
          if (IsSchBoxTransparence(SchBox) || IsSchBoxCluster(SchBox))
          {
            Layer = XSCH_CONSTRUCTION_LAYER;
          } else Layer = XSCH_SCHBOX_LAYER;
          X_box  = SchBox->X  * XSCH_UNIT;
          Y_box  = SchBox->Y  * XSCH_UNIT;
          Dx = SchBox->DX * XSCH_UNIT;
          Dy = SchBox->DY * XSCH_UNIT;

	  X_trace = X_box + X_fig;
	  Y_trace = Y_box + Y_fig;
        
          if (SchBox->SOURCE_TYPE == SCH_SOURCE_CNSCONE)
             {
 	      Object = XschAddTriangle( X_trace-XSCH_UNIT*2, Y_trace,
			                Dx + XSCH_UNIT*4, Dy, Layer );
             }
          else
             {
	      Object = XschAddRectangle( X_trace, Y_trace, Dx, Dy, Layer );
             };

	  Object->LINK = XschAddText( X_trace + ( Dx >> 1 ), 
				      Y_trace + ( Dy >> 1 ), 
				      XSCH_OBJECT_TEXT_CENTER, 
                                      SchBox->NAME, Layer );

	  Object->LINK->LINK = Object;
	  
	  Object->USER       = (void *)SchBox;
	  Object->LINK->USER = (void *)SchBox;
	  
	  SetXschSchBox( Object );
	  SetXschSchBox( Object->LINK );
	  

          if (SchBox->SOURCE_TYPE != SCH_SOURCE_CNSCONE) 
               {
	           	    trace_con(SchBox->CON_IN,X_trace,Y_trace,Layer);
	                    trace_con(SchBox->CON_OUT,X_trace,Y_trace,Layer);
	       };
         }
} 
