/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XSCH                            |
|                                                             |
| File    :                  xsch.c                           |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   01.06.96                        |
|                                                             |
\------------------------------------------------------------*/

# ident "@(#)XSCH ver 1.01 January 1997"

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>
# include <Xm/Xm.h>
# include MUT_H
# include AUT_H
# include MLO_H
# include CNS_H
# include SCL_H
# include XSB_H
# include XSC_H
# include XMX_H

# include "xsch.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                           present                           |
|                                                             |
\------------------------------------------------------------*/

void XschPresent()
{
  alliancebanner_with_authors( "Xsch", XSCH_VERSION,
                  "Graphical Schematic Viewer", "1997",
                  ALLIANCE_VERSION,
       "L.Jacomme, A.Lester, B.Miramond, S.Picault"  );
}

/*------------------------------------------------------------\
|                                                             |
|                            main                             |
|                                                             |
\------------------------------------------------------------*/

int main( argc, argv )

    int   argc;
    char *argv[];
{
  int  Debug   = 0;
  
  int  Index;
 
  XschPresent();

  mbkenv();
  autenv();
  cnsenv();

  for ( Index = 1;
        Index < argc;
        Index++ )
  {
    if ( ! strcmp( argv[ Index ], "-l" ) )
    {
      if ( ( Index + 1 ) < argc )
      {
        Index             = Index + 1;
        XschFirstFileName = argv[ Index ];
      }
    }
    else
    if ( ! strcmp( argv[ Index ], "-debug" ) )
    {
      Debug = 1;
    }
    else
    if ( ! strcmp( argv[ Index ], "-xor" ) )
    {
      XSCH_XOR_CURSOR = XSCH_TRUE;
    }
    else
    if ( ! strcmp( argv[ Index ], "-force" ) )
    {
      XSCH_FORCE_DISPLAY = XSCH_TRUE;
    }
  }

  if ( Debug ) autdebug();

  autbegin();

  Xschgetenv();
  XschLoadParameters();

  XschInitializeRessources( &argc, argv );
  XschInitializeErrorMessage( Debug );

  XtAppMainLoop( XschApplication ); 

  autend();

  return( 0 );
}
