/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XVPN                           |
|                                                             |
| File    :                   Map.h                           |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef XVPN_MAP
# define XVPN_MAP

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# define XVPN_B1UP   0
# define XVPN_B2UP   1
# define XVPN_B3UP   2

# define XVPN_VIEW_MAP_X        25
# define XVPN_VIEW_MAP_Y       520

# define XVPN_DEFAULT_MAP_X      0
# define XVPN_DEFAULT_MAP_Y      0
# define XVPN_DEFAULT_MAP_DX    40
# define XVPN_DEFAULT_MAP_DY    40

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
 
  extern Widget XvpnMapPanel;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void XvpnComputeUnitMap();
  extern void XvpnInitializeUnitMap();
  extern void XvpnDisplayUnitMap();

  extern void XvpnEnterMapPanel();
  extern void XvpnClearMapWindow();
  extern void XvpnResizeMapWindow();
  extern void XvpnRefreshMapWindow();
  extern void XvpnInitializeMapWindow();

  extern void CallbackCloseMap();
  extern void CallbackMapCompute();
  extern void CallbackMapResize();
  extern void CallbackMapExpose();
  extern void CallbackMapEvent();

# endif 
