/*------------------------------------------------------------\
|                                                             |
| Tool    :                    XVPN                           |
|                                                             |
| File    :                  Share.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include <Xm/Xm.h>

# include MUT_H
# include AUT_H
# include XSB_H
# include "XSB_share.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  short XVPN_ACTIVE_NAME_TABLE [ XVPN_MAX_ACTIVE_NAME ] = 
  {
    1, /* PLACE TEXT  */
    1  /* PLACE TRANS */
  };

  short XVPN_ACTIVE_LAYER_TABLE [ XVPN_MAX_LAYER ] = 
  {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1
  };

  char *XvpnFirstFileName   = (char *)NULL;
  char *XVPN_XMS_FILE_NAME  = (char *)NULL;

/*------------------------------------------------------------\
|                                                             |
|                       Table variables                       |
|                                                             |
\------------------------------------------------------------*/

  char  *XVPN_CURSOR_COLOR_NAME;
  char  *XVPN_BACKGROUND_COLOR_NAME;
  char  *XVPN_FOREGROUND_COLOR_NAME;
  char  *XVPN_ACCEPT_COLOR_NAME;
  char  *XVPN_CONNECT_COLOR_NAME;

  long   XVPN_CURSOR_SIZE;
  float  XVPN_LOWER_GRID_STEP;
  long   XVPN_UNIT;

/*------------------------------------------------------------\
|                                                             |
|                       Global Variables                      |
|                                                             |
\------------------------------------------------------------*/

  char *XVPN_PARAM_NAME = (char *)NULL;
  char *XVPN_LAYER_NAME_TABLE[ XVPN_MAX_LAYER ][ 3 ];

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      XvpnPostTreatString                    |
|                                                             |
\------------------------------------------------------------*/

char *XvpnPostTreatString( Text )

  char *Text;
{
  char OnlySpace;
  int  Counter;

  autbegin();

  if ( Text != (char *)NULL )
  {
    OnlySpace = 1;

    for ( Counter = 0; Text[ Counter ]; Counter++ )
    {
      if ( Text[ Counter ] != ' ' ) OnlySpace = 0;
    }

    if ( OnlySpace ) Text = (char *)NULL;
  }

  autend();
  return( Text );
}

/*------------------------------------------------------------\
|                                                             |
|                        Xvpngetenv                           |
|                                                             |
\------------------------------------------------------------*/

void Xvpngetenv()
{
  char *Env;

  Env = getenv( "HOME" );

  if ( Env == (char *)NULL )
  {
    XVPN_XMS_FILE_NAME = XMS_FILE_NAME;
  }
  else
  {
    XVPN_XMS_FILE_NAME =

     (char *)autallocblock( strlen( Env ) + strlen( XMS_FILE_NAME ) + 2 );

    strcpy( XVPN_XMS_FILE_NAME, Env );
    strcat( XVPN_XMS_FILE_NAME, "/" );
    strcat( XVPN_XMS_FILE_NAME, XMS_FILE_NAME );
  }
}
