/*------------------------------------------------------------\
|                                                             |
| Tool    :                   XVPN                            |
|                                                             |
| File    :                  Bound.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <stdlib.h>
# include MUT_H
# include AUT_H
# include VEX_H
# include VPN_H
# include XSB_H
# include XVP_H
# include "XVP_bound.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  long         XvpnBoundXmin   = 0;
  long         XvpnBoundYmin   = 0;
  long         XvpnBoundXmax   = 0;
  long         XvpnBoundYmax   = 0;

  char         XvpnRecomputeBound = XVPN_TRUE; 

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     XvpnComputeBound                       |
|                                                             |
\------------------------------------------------------------*/

char XvpnComputeBound()

{
  xvpnobj_list *Obj;
  short         Layer;
  short         FirstBound;

  if ( XvpnFigure == (xvpnfig_list *)NULL )
  {
    return( XVPN_FALSE );
  }

  if ( XvpnRecomputeBound == XVPN_FALSE )
  {
    return( XVPN_TRUE );
  }

  autbegin();

  FirstBound = 1;

  for ( Layer = 0; Layer < XVPN_MAX_LAYER; Layer++ )
  {
    for ( Obj  = XvpnFigure->OBJECT[ Layer ];
          Obj != (xvpnobj_list *)NULL;
          Obj  = Obj->NEXT )
    {
      if ( FirstBound )
      {
        XvpnBoundXmin   = Obj->X;
        XvpnBoundYmin   = Obj->Y;
        XvpnBoundXmax   = Obj->X + Obj->DX;
        XvpnBoundYmax   = Obj->Y + Obj->DY;
        FirstBound      = 0;
      }
      else
      {
        if ( Obj->X < XvpnBoundXmin )
        {
          XvpnBoundXmin = Obj->X;
        }

        if ( Obj->Y < XvpnBoundYmin )
        {
          XvpnBoundYmin = Obj->Y;
        }

        if ( ( Obj->X + Obj->DX ) > XvpnBoundXmax )
        {
          XvpnBoundXmax = Obj->X + Obj->DX;
        }

        if ( ( Obj->Y + Obj->DY ) > XvpnBoundYmax )
        {
          XvpnBoundYmax = Obj->Y + Obj->DY;
        }
      }
    }
  }

  XvpnBoundXmin = XvpnBoundXmin - ( XVPN_UNIT << 1 );
  XvpnBoundYmin = XvpnBoundYmin - ( XVPN_UNIT << 1 );
  XvpnBoundXmax = XvpnBoundXmax + ( XVPN_UNIT << 1 );
  XvpnBoundYmax = XvpnBoundYmax + ( XVPN_UNIT << 1 );

  XvpnRecomputeBound = XVPN_FALSE;

  autend();
  return( XVPN_TRUE );
}
