/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

extern locon_list *scan_in_sig    ;/* scin connector */
extern locon_list *scan_out_sig  ;/* scout connector */
extern locon_list *clock_sig      ;/* clock connector */
extern locon_list *test_sig      ;/* test connector */
extern locon_list *vdd_sig        ;
extern locon_list *vss_sig        ;
extern locon_list *bist_mode1_sig ;

extern int nbr_inputs  ;      /* number of input signals */
extern int nbr_outputs ;      /* number of output signals */

extern  int ff_only ;

extern int test_mode  ;     /* test signal polarity  1= test_mode 0= fonc_mode */
extern int clock_mode ;     /* clock signal polarity 0= falling edge 1= rising edge */
extern int scan_ff_mode ;  /* scan enable for scan_dff gates */

extern char *scan_in   ;
extern char *scan_out  ;
extern char *clock_    ;
extern char *test      ;

extern char *SCAN_FF;   
extern char *SCAN_FF_N;

extern char * D_FF;    
extern char * D_FF_N ;  

extern char * LATCH_1 ; 
extern char * LATCH_1_N;
extern char * LATCH_2  ;
extern char * LATCH_2_N;
extern char * LATCH_3  ;
extern char * LATCH_3_N;
extern char * LATCH_4  ;
extern char * LATCH_4_N;
extern char * LATCH_5  ;
extern char * LATCH_5_N ;
extern char *LATCH_6    ;
extern char * LATCH_6_N ;

extern char * TSTATE1  ;
extern char *TSTATE1_N;
extern char * TSTATE ;

extern char * AND_GATE; 
extern char * NAND_GATE;  
extern char * NOR_GATE; 
extern char * XOR_GATE ;
extern char * MUX_GATE ;
extern char * INV_GATE;

/* scan cell connectors names */

extern char * SCAN_FF_SCIN  ;
extern char * SCAN_FF_OUT  ;
extern char * SCAN_FF_IN  ;
extern char * SCAN_FF_SE ;
extern char * SCAN_FF_CLOCK;

/* flip-flop cell connectors names */

extern char * FF_IN  ;
extern char * FF_OUT ;
extern char * FF_CLOCK ;

extern void get_signals_names();
extern void get_environment_variables();
extern void get_special_signals();












