/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define BILBO 1
#define FONC  4
#define DEFAULT 2

#define CVR_ERROR -1

extern lofig_list *ptfig;             /* pointer to the global netlist */

extern lofig_list *misr_fig ;   /* pointer to the misr generated model */
extern lofig_list *lfsr_fig ;   /* pointer to the lfsr generated model */
extern lofig_list *mux_fig ;    /* pointer to the mux  generated model */
extern lofig_list *bilbo_fig;  /* pointer to the bilbo generated model */

extern chain_list  *scan_ptr ;  /* list of the ffs in the scan path */
extern chain_list  *scan_order;/* list of the ff in the scanpath_order file */
extern chain_list  *mem_ptr;   /* list of memory cells */
extern chain_list  *in_ptr;           /* list of input connectors */
extern chain_list  *out_ptr ;         /* list of output connectors */




extern int nbr_inputs;
extern int nbr_outputs;
extern int mem_nbr;
extern int nbr_scan;

extern char *test;

extern locon_list *scan_in_sig   ;/*scin connector */
extern locon_list *scan_out_sig  ;/*scout connector */
extern locon_list *clock_sig     ;/*clock connector */
extern locon_list *test_sig      ;/*test connector */
extern locon_list *vdd_sig       ;
extern locon_list *vss_sig       ;
extern locon_list *bist_mode1_sig ;/* bist mode control */

extern int clock_mode;
extern int test_mode; 

extern chain_list  *in_ptr ;/* list of input connectors */
extern chain_list  *out_ptr ;/* list of output connectors */
extern chain_list  *mem_ptr ;/* list of latch and flip-flop instances */
extern chain_list  *scan_ptr;/* list of the ffs in the scan path */

extern int bilbo;
extern int nobist ; /* true for -nobist option */
extern int scan_insert ; /* true for -s option */







