/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<stdio.h>
#include MUT_H
#include MLO_H
#include "utile.h"
#include "genscan.h"

long max_index  = 0;      /* maximum INDEX number */

char *itostr(str,nbr)
char *str;
int   nbr;
{
char *s = (char *)mbkalloc(strlen(str)+5);
strcpy(s,str);
strcat(s,"%d");
sprintf(s,s,nbr);
return ((char *)s);
}
void Usage(nom)
char *nom;
{
printf("\n");
printf("Usage : %s <input_file> <output_file> [options]\n",nom);
printf(" -s <ScanOrderFileName>  \n");
printf(" -n  Fixed scan_out signal\n");
/*printf(" -e  Extracting Scan-Path\n");*/
printf("\n");
exit (1);
}


char *busname(name)
char *name;
{
char *tmp_name = (char *)mbkalloc(strlen(name));
char *s, *t;
        if (!name) {
                     printf("error in procedure busname\n");
                     return NULL;
                   }
        s = name;
        t = tmp_name;
        while((*s != ' ') && (*s != '\0')) 
        {
                *t++ = *s++;
        }
        *t = '\0';
        return (tmp_name);
}

char *busindex(name)
char *name;
{
	char *tmp_index; 
	char  *s, *t;
	char blank_found = 0;

	tmp_index=(char *)mbkalloc(strlen(name));
	
	if (!name) {
		printf("error in procedure busname\n");
		return NULL;
	}
	t = tmp_index;
	s = name;
	while (*s != '\0') 
	{
		if (*s == ' ') {s++;blank_found =1;break;}
		else ++s;
	}
	
	if (blank_found)
        while (*s !='\0') { *t++=*s++;}

	*t = '\0';
	return tmp_index;
}


/*******************************************************************************************************************/
/*                                                                                                                 */
/*                          Useful function to display locon and loins lists                                       */
/*                                                                                                                 */
/*******************************************************************************************************************/
void display_locon_list(p)
chain_list *p;
{ 
	chain_list *ptr; 
	for(ptr = p ; ptr!=NULL ; ptr = ptr->NEXT)
	{
		printf(" %s\n",((locon_list *)(ptr->DATA))->NAME);
	}
}


void display_loins_list(p)
chain_list *p;
{ 
	chain_list *ptr; 
	for(ptr = p ; ptr!=NULL ;ptr = ptr->NEXT)
	{
		printf(" %s\n",((loins_list *)(ptr->DATA))->INSNAME);
	}
}

void display_lists()
{
	
	printf("Liste des points memoire de la netliste\n");
	display_loins_list(mem_ptr);

	printf("Liste des points memoire du chemin de test\n");
	display_loins_list(scan_ptr);
	
}

/*******************************************************************************************************************/
/*               
                                   */
/*     This function Gets the pointer to the LOCON connector in the instance pointed by ptri                       */
/*               
                                   */
/*******************************************************************************************************************/
 
locon_list *get_con(ptri,connector)
loins_list *ptri;
char *connector;
{
    locon_list *ptr1;
        
                        for ( ptr1 = ptri->LOCON ; ptr1 != NULL ; ptr1 = ptr1->NEXT)
                                {
                                        if ( ptr1->NAME == namealloc(connector)) return ptr1;           
                                }
        printf("no connector %s in model %s \n",connector,ptri->FIGNAME);
        exit(1);
        
}       
locon_list *get_con_fig(ptri,connector)
lofig_list *ptri;
char *connector;
{
    locon_list *ptr1;
        
                        for ( ptr1 = ptri->LOCON ; ptr1 != NULL ; ptr1 = ptr1->NEXT)
                                {
                                        if ( ptr1->NAME == namealloc(connector)) return ptr1;           
                                }
        printf("no connector %s in model %s \n",connector,ptri->NAME);
        exit(1);
        
}       
 

/*******************************************************************************************************************/
/*                                                                                                                 */
/*                              search of the maximum signals INDEX                                                */
/*                                                                                                                 */
/*******************************************************************************************************************/

long get_max_index(ptfig)
lofig_list *ptfig;
{
	losig_list *pts;
	long i = 0;
	
	for(pts = ptfig->LOSIG ; pts ; pts = pts->NEXT)
	{
		if ((pts->INDEX) > i) 
		{ 
			i = pts->INDEX; 
		}
		
	}
	return(i);
	
}


/*******************************************************************************************************************/
/*                                                                                                                 */
/*                          gets a new number of signal INDEX                                                      */
/*                                                                                                                 */
/*******************************************************************************************************************/

long get_index()
{
	max_index = max_index +1;
	/* printf("index \n",max_index);*/
	return(max_index);
}



